{ ****** PARAMETRE ****** }

Type TpParam = Record
         n : string[4];
         m : byte;   { 0=> rien 1=> Flip/Flop +-  2=paramtre }
       End;

Const P_Rien = 0;
      P_Flip = 1;
      P_Egal = 2;

      CFGFileName : string[12] = 'XSERTEST.CFG';

      NbParam = 11;
      TabParam : array[1..NbParam] of TpParam = (
        ( n:'MDA';  m:P_Rien ),  { ecran mono }
        ( n:'CGA';  m:P_Rien ),  { ecran CGA 25 lignes }
        ( n:'EGA';  m:P_Rien ),  { ecran EGA 43 lignes ou VGA 50 lignes }
        ( n:'BW';   m:P_Flip ),  { force l'affichage en noir et blanc }
        ( n:'COM';  m:P_Egal ),  { COM=n,adresse,irq }
        ( n:'WIN';  m:P_Egal ),  { WIN=n,x,y }
        ( n:'ACT';  m:P_Flip ),  { active toutes les COM o regUART<>0 }
        ( n:'VER';  m:P_Flip ),  { active ou non la verification de l'UART }
        ( n:'CKNO'; m:P_Rien ),  { pas de CheckUp "rsident" }
        ( n:'CKXT'; m:P_Egal ),  { CKXT=vitesse }
        ( n:'CKAT'; m:P_Egal )   { CKAT=vitesse }
        );

      _MDA  = 1;
      _CGA  = 2;
      _EGA  = 3;
      _BW   = 4;
      _COM  = 5;
      _WIN  = 6;
      _ACT  = 7;
      _VER  = 8;
      _CKNO = 9;
      _CKXT = 10;
      _CKAT = 11;


function FileParam( var f : text ) : boolean;
var s : string;
    r : DirStr;
    n : NameStr;
    e : ExtStr;
begin
  FileParam := TRUE;

  { recherche d'abord dans le rpertoire courant }
  Assign(f,CFGFileName);
  reset(f);
  if IoResult=0 then exit;

  { recherche dans le rpertoire o est l'executable }
  s := ParamStr(0);
  if s<>'' then
    begin
      FSplit(s,r,n,e);
      Assign(f,r+CFGFileName);
      reset(f);
      if IoResult=0 then exit;
    end;

  { recherche dans le PATH dos }
  s := FSearch(CFGFileName,GetEnv('PATH'));
  if s<>'' then
    begin
      Assign(f,s);
      reset(f);
      if IoResult=0 then exit;
    end;

  FileParam := FALSE;
end;


Function ValBin( Var S : String; Var x : Longint ) : Boolean; Assembler;
Asm
    cld
    push ds
    lds  si, [S]
    lodsb               { lire la longueur de la chaine }
    xor  ah, ah         { longueur de la chaine dans AX }

    mov  cx, ax
    jcxz @FALSE         { saute si chaine vide }
    xor  bx, bx
    xor  dx, dx         { dx:bx = entier long en cours d'etude }
@BOUCLE:
    lodsb               { lit le car }
    sub  al, '0'        { -'0' }
    cmp  al, 1
    ja   @FALSE         { erreur de syntaxe! '0' ou '1' seulement ! }
    cmc                 { car, si al=1 => cf=0, si al<1 => cf=1 !! }
    rcl  bx, 1          { rotate with carry }
    rcl  dx, 1
    jc   @FALSE         { depassement de capacit 16 bits ! }
    loop @BOUCLE

    lds  si, [x]
    mov  [si], bx
    mov  [si+2], dx     { ecrit le resultat }
    mov  al, TRUE       { sort avec TRUE }
    JMP  @FIN
@FALSE:
    XOR  AL, AL
@FIN:
    pop  ds
End;


Function ValHex( Var S : String; Var x : Longint ) : Boolean; Assembler;
Asm
        cld
        push ds
        lds  si, [S]
        lodsb
        xor  ah, ah         { longueur de la chaine dans AX }
        mov  cx, ax
        jcxz @FALSE         { saute si vide }
        xor  bx, bx
        xor  dx, dx         { dx:bx = entier long en cours d'etude }
@BOUCLE:
        lodsb               { lit le car }
        cmp  al, 'a'
        jb   @03
        cmp  al, 'f'
        ja   @FALSE         { car incorrecte }
        sub  al, 32         { -32!  UpCase(al) }
        jmp  @05
@03:
        cmp  al, '0'
        jb   @FALSE
        cmp  al, '9'
        ja   @04
        {
          0..9
        }
        sub  al, '0'
        jmp  @CONT
@04:
        cmp  al, 'A'
        jb   @FALSE
        cmp  al, 'F'
        ja   @FALSE
        {
          A..F
        }
@05:
        sub  al, 'A'-10
@CONT:
        test dx, 0F000h
        jnz  @FALSE         { depassement de capacit }
        push cx             { sauve cx }
        mov  cl, 4
        shl  dx, cl         { dx*16  dx= xxxx xxxx xxxx 0000 }
        mov  ah, bh         {        ah= ???? xxxx           }
        shr  ah, cl         {        ah= 0000 ????           }
        or   dl, ah         {        dx= xxxx xxxx xxxx ???? }
        shl  bx, cl
        or   bl, al
        pop  cx             { restore cx }
        loop @BOUCLE

        lds  si, [x]
        mov  [si], bx
        mov  [si+2], dx     { ecrit le resultat }
        mov  al, TRUE       { sort avec TRUE }
        JMP  @FIN
@FALSE:
        xor  al, al
@FIN:
        pop  ds
End;


{ traduction en fonction du type de nombre }

Function ValX( Var S : String; Var x : Longint ) : Boolean;
Var SN  : String[32];
    Err : Word;
Begin
  If (S<>'') And (Length(S)<SizeOf(SN)) Then
    Case UpCase(S[1]) Of
      '%','B' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  ValX := ValBin(SN,x);
                End;
      '$','H' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  ValX := ValHex(SN,x);
                End;
      '#','D' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  Val(SN,x,Err);
                  ValX := Err=0;
                End;
    Else
      Case UpCase(S[Length(S)]) Of
        'B' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                ValX := ValBin(SN,x);
              End;
        'H' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                ValX := ValHex(SN,x);
              End;
        'D' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                Val(SN,x,Err);
                ValX := Err=0;
              End;
      Else
        Begin
          Val(S,x,Err);
          ValX := Err=0;
        End;
      End
    End
  Else ValX := FALSE;
End;



function StrVal( var s : string; nPar : word;
                 var result : Word; default : Word ) : boolean;
var i : word;
    n : string[20];
    x : longint;
begin
  i := 1;
  while nPar>1 do
    begin
      while (i<=length(s)) and (s[i]<>',') do inc(i);
      if i>length(s) then
        begin
          result := default;
          StrVal := TRUE;
          exit;
        end;
      dec(nPar);
      inc(i);
    end;
  n := '';
  while (i<=length(s)) and (s[i]<>',') do
    begin
      inc(n[0]);
      n[length(n)] := s[i];
      inc(i);
    end;
  if n='' then
    begin
      result := default;
      StrVal := TRUE;
    end
  else
    begin
      If ValX(n,x) And (x>=0) And (x<=65535) then
        begin
          result := Word(x);
          StrVal := TRUE;
        end
      else StrVal := FALSE;
    end;
end;



function ChargeParam : boolean;
var f    : text;
    Disk : boolean;
    nPar : word;
    xPar : word;
    nLig : word;
    EndB : boolean;
    Lig  : string;

  procedure go;
  var n  : word;

    procedure Erreur( txt : string );
    begin
      if Disk then writeln(txt,'   n',nLig,'  param.n',n)
      else writeln(txt,'   param.n',xPar);
      EndB := TRUE;
    end;

    procedure DoIt( p : TpParam; Plus : boolean; var sp : string );
    var i : word;
        nCom : Word;
        RegU : Word;
        nIrq : Word;
        SizeIn : Word;
        SizeOut : Word;

        nWin : Word Absolute nCom;
        WinX : Word Absolute RegU;
        WinY : Word Absolute nIrq;
        Speed : Word Absolute nCom;
    begin
    {  writeln(nLig:4,' ',n:4,' "',p.n,'" ',p.m,' ',Plus,' "',sp,'"'); }
      for i := 1 to length(p.n) do p.n[i] := UpCase(p.n[i]);
      for i := 1 to NbParam do
        if TabParam[i].n=p.n then
          begin
            if (TabParam[i].m<>p.m) And
               Not((p.m=P_Rien) And (TabParam[i].m=P_Flip)) Then
              begin
                Erreur('Option mal utilise');
                exit;
              end;
            case i of
              _MDA  : VideoMode := VMODE_MDA;
              _CGA  : VideoMode := VMODE_CGA;
              _EGA  : VideoMode := VMODE_EGA;
              _BW   : CBlckWht  := Plus;
              _COM  : If StrVal(sp,1,nCom,0) And
                         (nCom>0) And (nCom<=MAXCOM) And
                         StrVal(sp,2,RegU,0) And
                         (RegU And 7=0) And
                         StrVal(sp,3,nIrq,$FF) And
                         ((nIrq<16) or (nIrq=$FF)) And
                         StrVal(sp,4,SizeIn,1024) And
                         StrVal(sp,5,SizeOut,1024) And
                         GoodRegUART(RegU) Then
                        Begin
                          TabCom[nCom].RegUART := RegU And Not(7);
                          TabCom[nCom].SizeIn  := SizeIn;
                          TabCom[nCom].SizeOut := SizeOut;
                          If nIrq=$FF Then
                            Begin
                              TabCom[nCom].nIrq    := 0;
                              TabCom[nCom].ChxIrq  := $FF;
                            End
                          Else
                            Begin
                              TabCom[nCom].nIrq    := nIrq;
                              TabCom[nCom].ChxIrq  := nIrq;
                            End;
                        End
                      Else Erreur('Paramtre incorrect');
              _WIN  : If StrVal(sp,1,nWin,$FF) And
                         (nWin>=0) And (nWin<=MAXCOM) And
                         StrVal(sp,2,WinX,0) And
                         StrVal(sp,3,WinY,0) Then
                        Begin
                          TabWin[nWin].x := Byte(WinX);
                          TabWin[nWin].y := Byte(WinY);
                        End
                      Else Erreur('Paramtre incorrect');
              _ACT  : ActiveCom := Plus;
              _VER  : VerifyUART := Plus;
              _CKNO : CheckUpMode := CHECKUP_NIL;
              _CKXT : If StrVal(sp,1,Speed,4) And (Speed<=15) Then
                        Begin
                          CheckUpMode  := CHECKUP_XT;
                          CheckUpSpeed := Speed;
                        End
                      Else Erreur('Paramtre incorrect');
              _CKAT : If StrVal(sp,1,Speed,7) And (Speed<=15) Then
                        Begin
                          CheckUpMode  := CHECKUP_AT;
                          CheckUpSpeed := Speed;
                        End
                      Else Erreur('Paramtre incorrect');
            else Erreur('Option hors service');
            end;
            exit;
          end;
      Erreur('Option inconnu');
    end;

  var is   : word;
      d    : string;
      v    : string;
      ir   : word;
      p    : TpParam;
      x    : word;
  begin
    inc(nLig);
    is := 0;
    n  := 0;
    while not(EndB) and (is<length(Lig)) do
      begin
        d := '';
        inc(is);
        while (is<=length(Lig)) and (Lig[is]<>' ') do
          begin
            inc(d[0]);
            d[length(d)] := Lig[is];
            inc(is);
          end;

        ir := 1;
        while not(EndB) and (ir<=length(d)) do
          begin
            v := '';
            if d[ir]='/' then
              begin
                v := '/';
                inc(ir);
              end;
            while (ir<=length(d)) and (d[ir]<>'/') do
              begin
                inc(v[0]);
                v[length(v)] := d[ir];
                inc(ir);
              end;

            if v<>'' then
              begin
                inc(n);
                inc(xPar);
                if v[1]='/' then
                  begin
                    if v[length(v)]='+' then
                      begin
                        p.n  := copy(v,2,length(v)-2);
                        p.m  := P_Flip;
                        v    := '';
                        DoIt(p,TRUE,v);
                      end
                    else
                      if v[length(v)]='-' then
                        begin
                          p.n  := copy(v,2,length(v)-2);
                          p.m  := P_Flip;
                          v    := '';
                          DoIt(p,FALSE,v);
                        end
                      else
                        begin
                          x := Pos('=',v);
                          if x=0 then
                            begin
                              p.n := copy(v,2,length(v)-1);
                              p.m := P_Rien;
                              v   := '';
                              DoIt(p,TRUE,v);
                            end
                          else
                            begin
                              p.n := copy(v,2,x-2);
                              p.m := P_Egal;
                              v   := copy(v,x+1,255);
                              DoIt(p,FALSE,v);
                            end;
                        end;
                  end
                else
                  begin
                    Erreur('missing file name');
                    exit;
                  end;
              end;
          end;
      end;
  end;

begin
  ChargeParam := FALSE;

  Disk := FileParam(f);
  nPar := 0;
  xPar := 0;
  nLig := 0;

  EndB := FALSE;

  while not(EndB) do
    begin
      if Disk then
        begin
          if not(Eof(f)) then
            begin
              Readln(f,Lig);
              go;
            end;
          if Eof(f) then
            begin
              Close(f);
              Disk := FALSE;
              xPar := 0;
            end;
        end
      else
        begin
          if nPar<ParamCount then
            begin
              inc(nPar);
              Lig := ParamStr(nPar);
              go;
            end
          else
            begin
              EndB := TRUE;
              ChargeParam := TRUE;
            end;
        end;
    end;
  if Disk then Close(f);
end;


Function Byte2Hex( x : Byte ) : String; Assembler;
Asm
    cld

    les  di, [@Result]
    mov  [BYTE PTR es:di], 2    { car "00" a une longueur fixe de 2 }
    inc  di                      { se place }

    mov  al, [x]
    mov  cl, 4
    shr  al, cl            { decal les 4 bits suprieur }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
    mov  al, [x]
    and  al, 15            { les 4 bits infrieurs }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
End;


Function Word2Hex( x : Word ) : String; Assembler;
Asm
    cld

    les  di, [@Result]
    mov  [BYTE PTR es:di], 4   { car "0000" a une longueur fixe de 4 }
    inc  di                { se place }

    mov  cl, 4
    mov  bx, [x]
    mov  al, bh
    shr  al, cl            { decal les 4 bits suprieur }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
    mov  al, bh
    and  al, 15            { les 4 bits infrieurs }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
    mov  al, bl
    shr  al, cl            { decal les 4 bits suprieur }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
    mov  al, bl
    and  al, 15            { les 4 bits infrieurs }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
End;
