{$A+,B-,E-,F-,I-,N-,O-,V-,X+ }

{$IFDEF P286 } {$G+ } {$ELSE } {$G- } {$ENDIF }

{$IFDEF DEBUG } {$R+,S+ } {$ELSE } {$D-,L-,R-,S- } {$ENDIF }

{$M 16384, 0, 655360 }

Program XSerTest;

Uses Dos, XSer;

{$I XWIN.PAS }

Type FldCoord = Record
         x, y : Byte;
       End;

Const MAXIN = 14;
      MAXOUT = 3;

      FLD_IRQ   = 1;
      FLD_BAUD  = 2;
      FLD_PAR   = 3;
      FLD_DATA  = 4;
      FLD_STOP  = 5;
      FLD_BRK   = 6;
      FLD_DTR   = 7;
      FLD_RTS   = 8;
      FLD_OUT1  = 9;
      FLD_OUT2  = 10;
      FLD_LOOP  = 11;
      FLD_OPEN  = 12;
      FLD_OUT   = 13;

      FLD_MAX   = 13;

      FLDXY : Array[1..FLD_MAX] Of FldCoord = (
          ( x:9; y:2 ),
          ( x:9; y:4 ),
          ( x:9; y:5 ),
          ( x:9; y:6 ),
          ( x:9; y:7 ),
          ( x:5; y:9 ),
          ( x:10; y:9 ),
          ( x:10; y:10 ),
          ( x:10; y:11 ),
          ( x:10; y:12 ),
          ( x:10; y:13 ),
          ( x:1; y:11 ),
          ( x:8; y:13 )
        );

      PhraseTest : String[47] = 'Portez ce vieux whisky au juge blond qui fume.';

      FOUTMODE_ALPHA  = 0;
      FOUTMODE_TEXT   = 1;

Type BufferIn = Array[1..MAXIN] Of Char;
     BufferOut = Array[1..MAXOUT] Of Char;

     WinCom = Record
         Phase   : Byte;
         nFld    : Byte;
         FOut    : Boolean;   { TRUE => sortie constante active }
         FOutMode: Byte;      { 0=>alphabet, 1=>phrase }
         LCar    : Char;      { car prochain  emettre }
         NCar    : Byte;      { ncar (si phrase test) }
         Win     : ZXWindow;
         Open    : Boolean;
         LastStatLine : Byte;
         DeltaModem : Boolean;
         BufIn   : BufferIn;
         BufOut  : BufferOut;
         Com     : ComX;
       End;

     PWinCom = ^WinCom;

Type ComRec = Record
         RegUART : Word;      { si $0000 => choix non fait }
         nIrq    : Byte;      { etat courant (0 ou ChxIrq) }
         ChxIrq  : Byte;      { si $FF => choix non fait   }
         SizeIn  : Word;
         SizeOut : Word;
         Wc      : PWinCom;
       End;

     WinRec = Record
         x, y    : Byte;
       End;

Const MAXCOM = 16;

Const CfgWinSup : ZXPlanCfg = ( Name:'SUPERVISEUR';
                                x:20; y:4; Lg:40; Ht:15; CodeKey:0;
                                Prior:0; Background:FALSE;
                                Enable:TRUE
                              );

      CHECKUP_NIL = 0;
      CHECKUP_XT  = 1;
      CHECKUP_AT  = 2;

Var TabCom       : Array[1..MAXCOM] Of ComRec;
    TabWin       : Array[0..MAXCOM] Of WinRec;
    ActiveCom    : Boolean;
    VerifyUART   : Boolean;
    CheckUpMode  : Byte;
    CheckUpSpeed : Byte;

Procedure InitXSerTest;
Var i : Byte;
Begin
  For i := 1 To MAXCOM Do
    With TabCom[i] Do
      Begin
        RegUART := 0;
        nIrq    := 0;
        ChxIrq  := $FF;
        SizeIn  := 1024;
        SizeOut := 1024;
        Wc      := NIL;
      End;

  TabWin[0].x := CfgWinSup.x;
  TabWin[0].y := CfgWinSup.y;

  For i := 1 To MAXCOM Do
    With TabWin[i] Do
      Begin
        x := ((i-1) mod 4)*20;
        y := ((i-1) Div 4)*17;
      End;

  ActiveCom    := TRUE;
  VerifyUART   := TRUE;
  CheckUpMode  := CHECKUP_NIL;
  CheckUpSpeed := 0;
End;


Const INOUTPUT   = 0;    { Reception/Transmission des donnes (DLAB=0) }
      ITVALID    = 1;    { Autorisation des interruptions     (DLAB=0) }
      ITIDEN     = 2;    { Identification des interruptions }
      LINECTRL   = 3;    { Contrle de la ligne }
      MODEMCTRL  = 4;    { Contrle des signaux modem }
      LINESTATE  = 5;    { Etat de la ligne }
      MODEMSTATE = 6;    { Etat des signaux modem }
      UNUSED     = 7;    { Inutilis }

      LINEBAUD   = 0;    { Vitesse communication (WORD)       (DLAB=1) }

      { ITVALID  : }

      ITINPUT    = $01;  { IT en reception }
      ITOUTPUT   = $02;  { IT en sortie }
      ITERROR    = $04;  { IT si erreur }
      ITMODEM    = $08;  { IT si changement d'etat du modem }

      { LINECTRL : }

      BREAKON    = $40;  { Gnrateur de BREAK }
      DLAB       = $80;  { DLAB ... }

      { ITIDEN }

      IDMODEM    = $00;
      IDOUTPUT   = $02;
      IDINPUT    = $04;
      IDERROR    = $06;

      { MODEMCTRL }

      CTRL_LOOP  = $10;  { Boucle UART sur lui-mme (pour tester) }




Function GoodRegUART( RegUART : Word ) : Boolean;
Begin
  GoodRegUART := (RegUART<>0) And
                 (Not(VerifyUART) Or
                 ((RegUART And 7=0) And
                  (Port[RegUART+LINESTATE] And (LN_THRE+LN_TSRE)=LN_THRE+LN_TSRE) And
                  (Port[RegUART+LINESTATE] And LN_ERROR=0)));
End;



{$I CONFIG.PAS }

Const INTKEYBOARD = $16;


Function ZXKeyPressed : Boolean; Assembler;
Asm
    MOV  AH, 01h
    INT  INTKEYBOARD
    JZ   @RIEN
    MOV  AL, TRUE
    JMP  @EXIT
@RIEN:
    XOR  AL, AL
@EXIT:
End;


Function ZXReadKey : Word; Assembler;
Asm
    MOV  AH, 00h
    INT  INTKEYBOARD
End;


Function ZXShiftStatus : Byte; Assembler;
Asm
    MOV  AH, 02h
    INT  INTKEYBOARD
End;
 

Function Val2Str( x : Longint; surf : Byte ) : String;
Var s : String;
Begin
  Str(x:surf,s);
  Val2Str := s;
End;
Function GetUARTSpeed( RegUART : Word ) : Word; Assembler;
Asm
    MOV  DX, [RegUART]
    ADD  DX, LINECTRL

    CLI

    IN   AL, DX
    OR   AL, DLAB
    OUT  DX, AL          { DLAB  1 }

    MOV  DX, [RegUART]
    IN   AL, DX
    MOV  BL, AL
    INC  DX
    IN   AL, DX
    MOV  BH, AL

    MOV  DX, [RegUART]
    ADD  DX, LINECTRL
    IN   AL, DX
    AND  AL, DLAB XOR 255
    OUT  DX, AL          { DLAB  0 }

    STI

    MOV  AX, BX
End;


Procedure SetUARTSpeed( RegUART : Word; Speed : Word ); Assembler;
Asm
    MOV  DX, [RegUART]
    ADD  DX, LINECTRL

    CLI

    IN   AL, DX
    OR   AL, DLAB
    OUT  DX, AL          { DLAB  1 }

    MOV  DX, [RegUART]
    MOV  AX, [Speed]
    OUT  DX, AL
    INC  DX
    MOV  AL, AH
    OUT  DX, AL

    MOV  DX, [RegUART]
    ADD  DX, LINECTRL
    IN   AL, DX
    AND  AL, DLAB XOR 255
    OUT  DX, AL          { DLAB  0 }

    STI
End;


Function GetUARTCtrlLine( RegUART : Word ) : Byte; Assembler;
Asm
    MOV  DX, [RegUART]
    ADD  DX, LINECTRL
    IN   AL, DX
End;


Procedure SetUARTCtrlLine( RegUART : Word; Param : Byte ); Assembler;
Asm
    MOV  AL, [Param]
    MOV  DX, [RegUART]
    ADD  DX, LINECTRL
    OUT  DX, AL
End;


Function GetUARTCtrlModem( RegUART : Word ) : Byte; Assembler;
Asm
    MOV  DX, [RegUART]
    ADD  DX, MODEMCTRL
    IN   AL, DX
End;


Procedure SetUARTCtrlModem( RegUART : Word; Param : Byte ); Assembler;
Asm
    MOV  AL, [Param]
    MOV  DX, [RegUART]
    ADD  DX, MODEMCTRL
    OUT  DX, AL
End;


Const QuitSoft   : Boolean = FALSE;


Procedure AffWcUART( Wc : PWinCom; RegUART : Word );
Begin
  Wc^.Win.SetColor(TextWhite);
  Wc^.Win.DirectWrite(9,1,Word2Hex(RegUART));
End;


Procedure AffWcIRQ( Wc : PWinCom; nIrq : Byte );
Begin
  Wc^.Win.SetColor(TextWhite);
  If nIrq=0 Then Wc^.Win.DirectWrite(9,2,'NONE')
  Else Wc^.Win.DirectWrite(9,2,Val2Str(nIrq,2)+'  ');
End;

Procedure AffWcSpeed( Wc : PWinCom; Speed : Word );
Begin
  Wc^.Win.SetColor(TextWhite);
  If Speed=0 Then Wc^.Win.DirectWrite(9,4,Val2Str(0,5))
  Else Wc^.Win.DirectWrite(9,4,Val2Str(Longint(115200) Div Longint(Speed),5));
End;


Procedure AffWcParity( Wc : PWinCom; Param : Byte );
Var p : Byte;
Begin
  Wc^.Win.SetColor(TextWhite);
  p := Param And $18;
  If p=ODDPARITY Then Wc^.Win.DirectWrite(9,5,'ODD ')
  Else
    If p=EVENPARITY Then Wc^.Win.DirectWrite(9,5,'EVEN')
    Else Wc^.Win.DirectWrite(9,5,'NONE');
End;


Procedure AffWcData( Wc : PWinCom; Param : Byte );
Begin
  Wc^.Win.SetColor(TextWhite);
  Wc^.Win.DirectWrite(9,6,Val2Str(5+(Param And 3),1));
End;


Procedure AffWcSTOP( Wc : PWinCom; Param : Byte );
Begin
  Wc^.Win.SetColor(TextWhite);
  If Param And STOP2BITS=0 Then Wc^.Win.DirectWrite(9,7,'1 ')
  Else
    If Param And 3=0 Then Wc^.Win.DirectWrite(9,7,'1')
    Else Wc^.Win.DirectWrite(9,7,'2 ');
End;


Procedure AffBitStat( Wc : PWinCom; data, nbit, x, y : Byte; Text : String );
Begin
  If data And (1 shl nbit)=0 Then Wc^.Win.SetColor(TextGray)
  Else Wc^.Win.SetColor(BackGray);
  Wc^.Win.DirectWrite(x,y,Text);
End;


Procedure AffWcBrk( Wc : PWinCom; Param : Byte );
Begin
  AffBitStat( Wc, Param, 6,5,9,'BRK ');
End;




Procedure AffWcCtrlLine( Wc : PWinCom; Param : Byte );
Begin
  AffWcParity( Wc, Param );
  AffWcData( Wc, Param );
  AffWcStop( Wc, Param );
  AffWcBrk( Wc, Param );
End;


Procedure AffWcCtrlModem( Wc : PWinCom; Modem : Byte );
Begin
  AffBitStat( Wc, Modem,0,10, 9,'DTR ');
  AffBitStat( Wc, Modem,1,10,10,'RTS ');
  AffBitStat( Wc, Modem,2,10,11,'OUT1');
  AffBitStat( Wc, Modem,3,10,12,'OUT2');
  AffBitStat( Wc, Modem,4,10,13,'LOOP');
End;


Procedure AffWcStat( Wc : PWinCom );
Begin
  Wc^.Win.SetColor(TextWhite);
  If Wc^.Open Then Wc^.Win.DirectWrite(1,11,'  OPEN  ')
  Else Wc^.Win.DirectWrite(1,11,' CLOSE  ');
End;


Procedure AffWcStatLine( Wc : PWinCom; RegUART : Word );
Var Data : Byte;
Begin
  If Wc^.Open Then
    If Wc^.Com.LineError Then Data := Wc^.Com.GetLineState
    Else Data := Wc^.LastStatLine
  Else Data := Port[RegUART+LINESTATE];

  If Data<>Wc^.LastStatLine Then
    Begin
      AffBitStat( Wc, Data,0,15, 1,'RDA ');
      AffBitStat( Wc, Data,1,15, 2,'OVRN');
      AffBitStat( Wc, Data,2,15, 3,'PAR.');
      AffBitStat( Wc, Data,3,15, 4,'FRA.');
      AffBitStat( Wc, Data,4,15, 5,'BRK ');
      AffBitStat( Wc, Data,5,15, 6,'THRE');
      AffBitStat( Wc, Data,6,15, 7,'TSRE');
      AffBitStat( Wc, Data,7,15, 8,'TOUT');
      Wc^.LastStatLine := Data;
    End;
End;


Procedure AffWcStatModem( Wc : PWinCom; RegUART : Word );
Var Data : Byte;
Begin
  If Wc^.Open Then
    If Wc^.Com.NewModemState Then Data := Wc^.Com.GetModemState or 15
    Else Data := 0
  Else Data := Port[RegUART+MODEMSTATE];

  If (Data And 15<>0) Or (Wc^.DeltaModem) Then
    Begin
      AffBitStat( Wc, Data,4,15,10,'CTS ');
      AffBitStat( Wc, Data,5,15,11,'DSR ');
      AffBitStat( Wc, Data,6,15,12,'RING');
      AffBitStat( Wc, Data,7,15,13,'DCD ');
      Wc^.DeltaModem := FALSE;
    End;
End;


Procedure AffWcBufIn( Wc : PWinCom );
Var i : Byte;
Begin
  Wc^.Win.SetColor(BackGray);
  For i := 1 To MAXIN Do Wc^.Win.DirectWrite(5+i-1,15,Wc^.BufIn[i]);
End;


Procedure AffWcReceiveData( Wc : PWinCom; c : Char );
Begin
  Move(Wc^.BufIn[2],Wc^.BufIn[1],MAXIN-1);
  Wc^.BufIn[MAXIN] := c;
  AffWcBufIn( Wc );
End;


Procedure AffWcGetData( Wc : PWinCom; RegUART : Word );
Var c : Char;
Begin
  If Wc^.Open Then
    Begin
      If Wc^.Com.ReceiveChar(c) Then AffWcReceiveData(Wc,c);
    End
  Else
    If Wc^.LastStatLine And 1<>0 Then
      AffWcReceiveData(Wc,Char(Port[RegUART]));
End;


Procedure AffWcBufOut( Wc : PWinCom );
Var i : Byte;
Begin
  Wc^.Win.SetColor(BackGray);
  For i := 1 To MAXOUT Do Wc^.Win.DirectWrite(6+i-1,13,Wc^.BufOut[i]);
End;


Procedure AffWcTransmitData( Wc : PWinCom; c : Char );
Begin
  Move(Wc^.BufOut[2],Wc^.BufOut[1],MAXOUT-1);
  Wc^.BufOut[MAXOUT] := c;
  AffWcBufOut( Wc );
End;


Function AffWcSendData( Wc : PWinCom; c : Char; RegUART : Word ) : Boolean;
Begin
  If Wc^.Open Then
    Begin
      If Wc^.Com.TransmitChar(c) Then
        Begin
          AffWcTransmitData(Wc,c);
          AffWcSendData := TRUE;
        End
      Else AffWcSendData := FALSE;
    End
  Else
    If Wc^.LastStatLine And 32<>0 Then
      Begin
        Port[RegUART] := Byte(c);
        AffWcTransmitData(Wc,c);
        AffWcSendData := TRUE;
      End
    Else AffWcSendData := FALSE;
End;


Procedure WcCursor( Wc : PWinCom );
Begin
  Wc^.Win.GotoXY(FLDXY[Wc^.nFld].x,FLDXY[Wc^.nFld].y);
End;



Const WCPHASE_INIT   = 1;
      WCPHASE_VEILLE = 2;



Procedure WcPgNext( nCom : Byte; Up : Boolean );
Var Wc  : PWinCom;
    Win : ^ZXWindow;
    cm  : ^ComRec;
    p   : Byte;
    z   : Byte;
    Speed : Word;
    mu  : Word;
    lev : Byte;
Begin
  cm := @TabCom[nCom];
  Wc := cm^.Wc;
  Win := @Wc^.Win;
  Case Wc^.nFld Of
    FLD_IRQ :
      If Not(Wc^.Open) Then
        Begin
          If (cm^.nIrq=0) And (cm^.ChxIrq<>$FF) Then cm^.nIrq := cm^.ChxIrq
          Else cm^.nIrq := 0;
          AffWcIRQ(Wc,cm^.nIrq);
        End;
    FLD_BAUD :
      Begin
        Speed := GetUARTSpeed(cm^.RegUART);
        If Speed>0 Then
          Begin
            mu := BAUD75 Div Speed;
            lev := 15;
            While (lev>0) And ((mu And (1 Shl Lev))=0) Do Dec(lev);
          End
        Else lev := 0;

        If Up Then
          If lev<9 Then Inc(lev) Else lev := 0
          Else If lev>0 Then Dec(lev) Else lev := 9;

        Speed := BAUD75 Shr lev;
        If Wc^.Open Then Wc^.Com.SetBaud(Speed)
        Else SetUARTSpeed(cm^.RegUART,Speed);
        AffWcSpeed(Wc,Speed);
      End;
    FLD_PAR :
      Begin
        p := GetUARTCtrlLine(cm^.RegUART);
        z := (p Shr 3) And 3;
        If Up Then
          If z<3 Then Inc(z) Else z := 0
        Else If z>0 Then Dec(z) Else z := 3;
        p := ( p And Not( 3 Shl 3)) Or ( z Shl 3);
        If Wc^.Open Then Wc^.Com.SetParam(p)
        Else SetUARTCtrlLine(cm^.RegUART,p);
        AffWcCtrlLine(Wc,p);
      End;
    FLD_DATA :
      Begin
        p := GetUARTCtrlLine(cm^.RegUART);
        z := p And 3;
        If Up Then
          If z<3 Then Inc(z) Else z := 0
        Else If z>0 Then Dec(z) Else z := 3;
        p := (p And Not( 3 )) Or z;
        If Wc^.Open Then Wc^.Com.SetParam(p)
        Else SetUARTCtrlLine(cm^.RegUART,p);
        AffWcCtrlLine(Wc,p);
      End;
    FLD_STOP :
      Begin
        p := GetUARTCtrlLine(cm^.RegUART);
        p := p Xor 4;
        If Wc^.Open Then Wc^.Com.SetParam(p)
        Else SetUARTCtrlLine(cm^.RegUART,p);
        AffWcCtrlLine(Wc,p);
      End;
    FLD_BRK :
      Begin
        p := GetUARTCtrlLine(cm^.RegUART);
        p := p Xor BREAKON;
        If Wc^.Open Then Wc^.Com.SetBreak(p And BreakON<>0)
        Else SetUARTCtrlLine(cm^.RegUART,p);
        AffWcCtrlLine(Wc,p);
      End;
    FLD_DTR..FLD_LOOP :
      Begin
        If Wc^.Open Then p := Wc^.Com.GetModemCtrl
        Else p := GetUARTCtrlModem(cm^.RegUART);
        p := p Xor (1 Shl (Wc^.nFld-FLD_DTR));
        If Wc^.Open Then Wc^.Com.SetModemCtrl(p)
        Else SetUARTCtrlModem(cm^.RegUART,p);
        AffWcCtrlModem(Wc,p);
      End;
    FLD_OPEN :
      Begin
        If Wc^.Open Then
          Begin
            Wc^.Com.Done;
            Wc^.Open := FALSE;
            Wc^.Phase := WCPHASE_INIT;
          End
        Else
          Begin
            If Wc^.Com.Init(cm^.RegUART,cm^.nIrq,
                            GetUARTSpeed(cm^.RegUART),
                            GetUARTCtrlLine(cm^.RegUART),
                            cm^.SizeIn,cm^.SizeOut) Then
              Begin
                Wc^.Open := TRUE;
                Wc^.Phase := WCPHASE_INIT;
              End;
          End;
      End;
    FLD_OUT :
      Begin
        If Not(Wc^.FOut) Then
          Begin
            Wc^.FOut := TRUE;
            If Up Then Wc^.FOutMode := FOUTMODE_ALPHA
            Else Wc^.FOutMode := FOUTMODE_TEXT;
            Wc^.LCar := #33;
            Wc^.NCar := 0;
          End
        Else Wc^.FOut := FALSE;
      End;
  End;
End;


Function  CreatWinCom( nCom : Byte ) : Boolean;
Var Wc  : PWinCom;
    Cfg : ZXPlanCfg;
    Win : ^ZXWindow;
    cm  : ^ComRec;
    rien: Byte;
    i   : Byte;
Begin
  cm := @TabCom[nCom];
  If cm^.Wc=Nil Then
    Begin
      GetMem(Wc,SizeOf(WinCom));
      If Wc<>NIL Then
        Begin
          Cfg.Name    := 'COM'+Val2Str(nCom,0);
          Cfg.x       := TabWin[nCom].x;
          Cfg.y       := TabWin[nCom].y;
          Cfg.Lg      := 20;
          Cfg.Ht      := 17;
          Cfg.CodeKey := nCom;
          Cfg.Prior   := 0;
          Cfg.Background := FALSE;
          Cfg.Enable:= FALSE;
          If Wc^.Win.Init(Cfg) Then
            Begin
              cm^.Wc := Wc;
              Wc^.Open := FALSE;

              Win := @Wc^.Win;
              Win^.Cursor(FALSE);
              Win^.Roll(FALSE);
              Win^.SetColor(TextGray);
              Win^.DirectWrite(1, 1,' UART:  RDA ');
              Win^.DirectWrite(1, 2,' IRQ :    OVRN');
              Win^.DirectWrite(1, 3,' ĴPAR.');
              Win^.DirectWrite(1, 4,' BAUD: FRA.');
              Win^.DirectWrite(1, 5,' PAR.:  BRK ');
              Win^.DirectWrite(1, 6,' DATA:     THRE');
              Win^.DirectWrite(1, 7,' STOP:    TSRE');
              Win^.DirectWrite(1, 8,' ĴTOUT');
              Win^.DirectWrite(1, 9,'  BRK DTR ');
              Win^.DirectWrite(1,10,'ĴRTS CTS ');
              Win^.DirectWrite(1,11,'OUT1DSR ');
              Win^.DirectWrite(1,12,'ĴOUT2RING');
              Win^.DirectWrite(1,13,'OUT: LOOPDCD ');
              Win^.DirectWrite(1,14,'');
              Win^.DirectWrite(1,15,'IN: ');

              Wc^.Phase := WCPHASE_INIT;
              Wc^.nFld  := FLD_IRQ;
              Wc^.FOut  := FALSE;
              Wc^.LastStatLine := 0;
              Wc^.DeltaModem := TRUE;
              rien := Port[cm^.RegUART];
              rien := Port[cm^.RegUART+LINESTATE];
              rien := Port[cm^.RegUART+MODEMSTATE];
              rien := Port[cm^.RegUART];
              rien := Port[cm^.RegUART+LINESTATE];
              rien := Port[cm^.RegUART+MODEMSTATE];
              For i := 1 To MAXIN Do Wc^.BufIn[i] := #0;
              AffWcBufIn(Wc);
              For i := 1 To MAXOUT Do Wc^.BufOut[i] := #0;
              AffWcBufOut(Wc);
              CreatWinCom := TRUE;
              Exit;
            End;
          FreeMem(Wc,SizeOf(WinCom));
        End;
    End;
  CreatWinCom := FALSE;
End;


Procedure RefreshWinCom( nCom : Byte; Key : Char; Fnct : Boolean );
Var Wc  : PWinCom;
    Win : ^ZXWindow;
    cm  : ^ComRec;
Begin
  cm := @TabCom[nCom];
  Wc := cm^.Wc;
  Win := @Wc^.Win;
  Case Wc^.Phase Of
    WCPHASE_INIT :
      Begin
        AffWcUART(Wc,cm^.RegUART);
        AffWcIRQ(Wc,cm^.nIrq);
        AffWcSpeed(Wc,GetUARTSpeed(cm^.RegUART));
        AffWcCtrlLine(Wc,GetUARTCtrlLine(cm^.RegUART));
        AffWcCtrlModem(Wc,GetUARTCtrlModem(cm^.RegUART));
        AffWcStat(Wc);
        Wc^.Phase := WCPHASE_VEILLE;
        Wc^.nFld := FLD_IRQ;
        Wc^.FOut := FALSE;
        Win^.Cursor(TRUE);
        WcCursor(Wc);
      End;
    WCPHASE_VEILLE :
      Begin
        AffWcStatLine(Wc,cm^.RegUART);
        AffWcStatModem(Wc,cm^.RegUART);
        AffWcGetData(Wc,cm^.RegUART);

        If Wc^.FOut Then
          Case Wc^.FOutMode Of
            FOUTMODE_TEXT :
              If AffWcSendData(Wc,PhraseTest[Wc^.NCar+1],cm^.RegUART) Then
                Begin
                  Inc(Wc^.NCar);
                  If Wc^.NCar>=Length(PhraseTest) Then Wc^.NCar := 0;
                End;
          Else
            If AffWcSendData(Wc,Wc^.LCar,cm^.RegUART) Then
              Begin
                Inc(Wc^.LCar);
                If Wc^.LCar>#127 Then Wc^.LCar := #33;
              End;
          End;

        If (Key<>#0) And (Wc^.Win.Active) Then
          If Not(Fnct) Then
            Begin
              If Wc^.nFld=FLD_OUT Then
                Begin
                  If AffWcSendData(Wc,Key,cm^.RegUART) Then ;
                End;
            End
          Else
            Begin
              Case Key Of
                #71 : Begin  { Home }
                        Wc^.nFld := FLD_IRQ;
                        WcCursor(Wc);
                      End;
                #72 : Begin  { cur haut }
                        Case Wc^.nFld Of
                          FLD_IRQ  : Wc^.nFld := FLD_LOOP;
                          FLD_DTR  : Wc^.nFld := FLD_STOP;
                          FLD_OPEN : Wc^.nFld := FLD_BRK;
                        Else Dec(Wc^.nFld);
                        End;
                        WcCursor(Wc);
                      End;
                #75,#77 : Begin  { cur gauche <- ou cur droit -> }
                        Case Wc^.nFld Of
                          FLD_BRK  : Wc^.nFld := FLD_DTR;
                          FLD_DTR  : Wc^.nFld := FLD_BRK;
                          FLD_OUT1 : Wc^.nFld := FLD_OPEN;
                          FLD_OPEN : Wc^.nFld := FLD_OUT1;
                          FLD_LOOP : Wc^.nFld := FLD_OUT;
                          FLD_OUT  : Wc^.nFld := FLD_LOOP;
                        End;
                        WcCursor(Wc);
                      End;
                #79 : Begin { End }
                        Wc^.nFld := FLD_LOOP;
                        WcCursor(Wc);
                      End;
                #80 : Begin { cur bas }
                        Case Wc^.nFld Of
                          FLD_STOP : Wc^.nFld := FLD_DTR;
                          FLD_LOOP, FLD_OUT : Wc^.nFld := FLD_IRQ;
                          FLD_BRK   : Wc^.nFld := FLD_OPEN;
                          FLD_OPEN : Wc^.nFld := FLD_OUT;
                        Else Inc(Wc^.nFld);
                        End;
                        WcCursor(Wc);
                      End;
                #81 : Begin
                        WcPgNext(nCom,TRUE);
                        WcCursor(Wc);
                      End;
                #73 : Begin
                        WcPgNext(nCom,FALSE);
                        WcCursor(Wc);
                      End;
              End;
            End;
      End;
  End;
End;


Var WinSup : ZXWindow;


Procedure AffGenerik;
Begin
  WinSup.Cursor(FALSE);
  WinSup.SetColor(TextWhite);
  WinSup.ClrScr;
  WinSup.SetColor(TextBlack+BackGray);
  WinSup.DirectWrite(12,2,' XSerTest v1.0E ');
  WinSup.SetColor(TextWhite);
  WinSup.DirectWrite(12,3,'----------------');
  WinSup.DirectWrite(14,4,'par T.Jaouen');
  WinSup.DirectWrite(3,6,'Logiciel permettant de tester les');
  WinSup.DirectWrite(3,7,'  ports sries, de COM1  COM16.');
  Case CheckUpMode Of
    CHECKUP_XT : WinSup.DirectWrite(3,9,'"CheckUp XT" install  '+
                                        Val2Str((Longint(1 Shl CheckUpSpeed)*182) Div 10,0)+' int./s');
    CHECKUP_AT : WinSup.DirectWrite(3,9,'"CheckUp AT" install  '+
                                        Val2Str(1 Shl (CheckUpSpeed+1),0)+' int./s');
  Else WinSup.DirectWrite(6,9,'Pas de "CheckUp" install');
  End;
  WinSup.SetColor(TextGray);
  WinSup.DirectWrite(11,12,'Appuyer une touche');
  WinSup.DirectWrite(5,13,'(ALT+X ou ALT+Q pour sortir)');
End;


Procedure AffMenu;
Begin
  WinSup.Cursor(FALSE);
  WinSup.SetColor(TextWhite);
  WinSup.ClrScr;
  WinSup.SetColor(TextBlack+BackGray);
  WinSup.DirectWrite(16,2,' Menu ');
  WinSup.SetColor(TextWhite);
  WinSup.DirectWrite(16,3,'------');
  WinSup.DirectWrite(5,5,'F1 - Aide');
  WinSup.DirectWrite(5,7,'F2 - Activer une COM');
  WinSup.DirectWrite(5,9,'F3 - Dsactiver une COM');
  WinSup.SetColor(TextGray);
  WinSup.DirectWrite(11,13,'Faites votre choix');
End;


Const NbPageAide = 7;

Var PageAide : Byte;

Procedure AffPageAide;
Begin

  WinSup.Cursor(FALSE);
  WinSup.SetColor(TextWhite);
  WinSup.ClrScr;
  WinSup.SetColor(TextBlack+BackGray);
  WinSup.DirectWrite(17,2,' Aide ');
  WinSup.SetColor(TextWhite);
  WinSup.DirectWrite(17,3,'------');

  Case PageAide Of
    0 : PageAide := 1;
    1 : Begin
          WinSup.DirectWrite(11,4,'--- Gnralits ---');
          WinSup.DirectWrite(1, 6,'Ce logiciel fonctionne avec le');
          WinSup.DirectWrite(1, 7,'principe des fentres.');
          WinSup.DirectWrite(1, 8,'Cette fentre "SUPERVISEUR" permet');
          WinSup.DirectWrite(1, 9,'de grer l''environement.');
          WinSup.DirectWrite(1,10,'Les autres fentres symbolisent les');
          WinSup.DirectWrite(1,11,'ports sries activs (ou declars).');
        End;
    2 : Begin
          WinSup.DirectWrite(12,4,'--- Fentres ---');
          WinSup.DirectWrite(1, 6,'[ALT]+[X]/[Q] : Quitter le programme');
          WinSup.DirectWrite(1, 7,'[ALT]+[?] : Activation d''une fentre');
          WinSup.DirectWrite(1, 8,'([ALT]+[0] : pour le "SUPERVISEUR")');
          WinSup.DirectWrite(1, 9,'[ALT]+[F3] : Desactiver une fentre');
          WinSup.DirectWrite(1,10,'[Shift]+[Cursor] : Dplace');
          WinSup.DirectWrite(1,11,'[Shift]+[PgUp]/[PgDn] : Avant/arrire');
        End;
    3 : Begin
          WinSup.DirectWrite(13,4,'--- Les COM ---');
          WinSup.DirectWrite(1, 6,'[Cursor] : Deplacement sur un champ');
          WinSup.DirectWrite(1, 7,'[PgUp]/[PgDn] : Modifier champ');
          WinSup.DirectWrite(1, 9,'UART: Adresse des registres sries');
          WinSup.DirectWrite(1,10,'IRQ : IRQ utilisable');
          WinSup.DirectWrite(1,11,'BAUD: Vitesse de communication');
          WinSup.DirectWrite(1,12,'PAR.: Parit');
        End;
    4 : Begin
          WinSup.DirectWrite(13,4,'--- Les COM ---');
          WinSup.DirectWrite(1, 6,'DATA: Longueur donnes');
          WinSup.DirectWrite(1, 7,'STOP: Nombre de bits');
          WinSup.DirectWrite(1, 8,'BRK : Emission d''un signal BREAK');
          WinSup.DirectWrite(1, 9,'DTR : Prt  recevoir');
          WinSup.DirectWrite(1,10,'RTS : Prt  emettre');
          WinSup.DirectWrite(1,11,'OUT1: ???');
        End;
    5 : Begin
          WinSup.DirectWrite(13,4,'--- Les COM ---');
          WinSup.DirectWrite(1, 6,'OUT2: Activation des interruptions');
          WinSup.DirectWrite(1, 7,'LOOP: Bouclage du circuit');
          WinSup.DirectWrite(1, 8,'CLOSE/OPEN : Ferme/Ouvre la com.');
          WinSup.DirectWrite(1, 9,'OUT : Envoi un flux de car. continu');
          WinSup.DirectWrite(1,10,'   (Ou taper une touche quelconque,');
          WinSup.DirectWrite(1,11,'    son code ASCII sera envoy).');
        End;
    6 : Begin
          WinSup.DirectWrite(13,4,'--- Les COM ---');
          WinSup.DirectWrite(1, 6,'RDA : Donne prte');
          WinSup.DirectWrite(1, 7,'OVRN: Erreur: donne ecrase');
          WinSup.DirectWrite(1, 8,'PAR.: Erreur: parit');
          WinSup.DirectWrite(1, 9,'FRA.: Erreur: bit stop');
          WinSup.DirectWrite(1,10,'BRK : Erreur: signal BREAK');
          WinSup.DirectWrite(1,11,'THRE: Sortie prte');
          WinSup.DirectWrite(1,12,'TSRE: Transmission achev');
        End;
    7 : Begin
          WinSup.DirectWrite(13,4,'--- Les COM ---');
          WinSup.DirectWrite(1, 6,'TOUT: "Time Out" ou inutilis');
          WinSup.DirectWrite(1, 7,'CTS : Modem prt  emettre');
          WinSup.DirectWrite(1, 8,'DSR : Modem prt  recevoir');
          WinSup.DirectWrite(1, 9,'RING: Dtection sonnerie');
          WinSup.DirectWrite(1,10,'DCD : Dtection de porteuse');
          WinSup.DirectWrite(1,11,'IN  : Reception des donnes');
        End;

  Else Dec(PageAide);
  End;

  WinSup.SetColor(TextGray);
  WinSup.DirectWrite(12,13,'[PgDn] --- [PgUp]');
  WinSup.DirectWrite(34,13,Val2Str(PageAide,2)+'/'+Val2Str(NbPageAide,2));
End;


Procedure AffAide;
Begin
  PageAide := 1;
  AffPageAide;
End;


Procedure PrecAide;
Begin
  If PageAide>1 Then
    Begin
      Dec(PageAide);
      AffPageAide;
    End;
End;


Procedure NextAide;
Begin
  If PageAide<NbPageAide Then
    Begin
      Inc(PageAide);
      AffPageAide;
    End;
End;


Var NumCom : Byte;

Procedure AffNumCom;
Begin
  WinSup.SetColor(TextWhite);
  WinSup.DirectWrite(2,5,'Slection COM n '+Val2Str(NumCom,2));
End;


Procedure AffKeySelect;
Begin
  WinSup.SetColor(TextGray);
  WinSup.DirectWrite(5,11,'[PgUp] ou [PgDn] pour changer');
  WinSup.DirectWrite(8,12,'(et aussi ['#24'] ou ['#25'])');
  WinSup.DirectWrite(11,13,'Puis taper [Entre <]');
End;


Procedure AffActiverCOM;
Begin
  NumCom := 1;

  WinSup.Cursor(FALSE);
  WinSup.SetColor(TextWhite);
  WinSup.ClrScr;
  WinSup.SetColor(TextBlack+BackGray);
  WinSup.DirectWrite(13,2,' Activer COM ');
  WinSup.SetColor(TextWhite);
  WinSup.DirectWrite(13,3,'-------------');

  AffNumCom;

  AffKeySelect;
End;


Procedure AffDesactiverCOM;
Begin
  NumCom := 1;

  WinSup.Cursor(FALSE);
  WinSup.SetColor(TextWhite);
  WinSup.ClrScr;
  WinSup.SetColor(TextBlack+BackGray);
  WinSup.DirectWrite(10,2,' Dsactiver COM ');
  WinSup.SetColor(TextWhite);
  WinSup.DirectWrite(10,3,'----------------');

  AffNumCom;

  AffKeySelect;
End;


Procedure PrecCOM;
Begin
  if NumCom>1 Then
    Begin
      Dec(NumCom);
      AffNumCom;
    End;
End;


Procedure NextCOM;
Begin
  if NumCom<MAXCOM Then
    Begin
      Inc(NumCom);
      AffNumCom;
    End;
End;


Var RegUART : Word;


Procedure AffRegUART;
Begin
  WinSup.SetColor(TextWhite);
  WinSup.DirectWrite(2,7,'Adresse registre '+Word2Hex(RegUART));
End;


Procedure AffCOMRegUART;
Begin
  RegUART := 0;
  AffRegUART;
End;


Procedure PrecUART( How : Word );
Begin
  Dec(RegUART,How);
  RegUART := RegUART And Not(7);
  AffRegUART;
End;


Procedure NextUART( How : Word );
Begin
  Inc(RegUART,How);
  RegUART := RegUART And Not(7);
  AffRegUART;
End;


Var ChxIrq : Byte;


Procedure AffChxIrq;
Begin
  WinSup.SetColor(TextWhite);
  WinSup.DirectWrite(12,9,'IRQ n ');
  If ChxIrq=0 Then WinSup.DirectWrite(19,9,'NONE')
  Else WinSup.DirectWrite(19,9,Val2Str(ChxIrq,2)+'  ');
End;


Procedure AffCOMChxIrq;
Begin
  ChxIrq := 0;
  AffChxIrq;
End;


Procedure PrecChxIrq;
Begin
  If ChxIrq=0 Then ChxIrq := 15
  Else Dec(ChxIrq);
  AffChxIrq;
End;


Procedure NextChxIrq;
Begin
  Inc(ChxIrq);
  If ChxIrq>=16 Then ChxIrq := 0;
  AffChxIrq;
End;


Procedure AffQuit;
Begin
  WinSup.Cursor(FALSE);
  WinSup.SetColor(TextWhite);
  WinSup.ClrScr;
  WinSup.SetColor(TextBlack+BackGray);
  WinSup.DirectWrite(15,2,' Quitter ');
  WinSup.SetColor(TextWhite);
  WinSup.DirectWrite(15,3,'---------');
  WinSup.DirectWrite(8,8,'Vous tes sr ? (O/N)');
  WinSup.GotoXY(30,8);
  WinSup.Cursor(TRUE);
End;


Procedure ActiveAllCom;
Var i : Byte;
Begin
  For i := 1 To MAXCOM Do
    If (TabCom[i].Wc=Nil) And (TabCom[i].ChxIrq<>$FF) And
       GoodRegUART(TabCom[i].RegUART) And
       CreatWinCom(i) Then ;
End;


Const SUPPHASE_INIT       = 0;
      SUPPHASE_PRESENT    = 1;
      SUPPHASE_MENUCHOIX  = 2;
      SUPPHASE_AIDE       = 4;
      SUPPHASE_ACTCOM     = 5;
      SUPPHASE_ACTCOMUART = 6;
      SUPPHASE_ACTCOM2    = 7;
      SUPPHASE_ACTCOMCHXIRQ = 8;
      SUPPHASE_QUIT       = 9;

      SupPhase : Word = SUPPHASE_INIT;

Procedure RefreshSup( Key : Char; Fnct : Boolean );
Begin
  If ((Key=#16) Or (Key=#45)) And Fnct And (SupPhase<>SUPPHASE_INIT) Then
    Begin
      If Not(WinSup.Active) Then
        Begin
          WinSup.Enable;
          WinSup.Foreground;
        End;
      AffQuit;
      SupPhase := SUPPHASE_QUIT;
    End;

  Case SupPhase Of
    SUPPHASE_INIT :
      Begin
        If ActiveCom Then
          Begin  { ouvrir toutes les fenetres de COM possible }
            ActiveAllCom;
          End;
        CfgWinSup.x := TabWin[0].x;
        CfgWinSup.y := TabWin[0].y;
        If WinSup.Init(CfgWinSup) Then
          Begin
            AffGenerik;
            SupPhase := SUPPHASE_PRESENT;
          End
        Else QuitSoft := TRUE;
      End;
    SUPPHASE_PRESENT :
      Begin
        If (Key<>#0) And (WinSup.Active) Then
          Begin
            AffMenu;
            SupPhase := SUPPHASE_MENUCHOIX;
          End;
      End;
    SUPPHASE_MENUCHOIX :
      Begin
        If (Key<>#0) And WinSup.Active Then
          If Fnct Then
            Begin
              Case Key Of
                #59 : Begin { F1 : Aide }
                        AffAide;
                        SupPhase := SUPPHASE_AIDE;
                      End;
                #60 : Begin { F2 : Activer une sortie COM }
                        AffActiverCom;
                        SupPhase := SUPPHASE_ACTCOM;
                      End;
                #61 : Begin { F3 : Desactiver une sortie COM }
                        AffDesactiverCom;
                        SupPhase := SUPPHASE_ACTCOM2;
                      End;
              End;
            End
          Else
            If Key=#27 Then
              Begin
                AffGenerik;
                SupPhase := SUPPHASE_PRESENT;
              End;
      End;
    SUPPHASE_AIDE :
      Begin
        If (Key<>#0) And WinSup.Active Then
          If Fnct Then
            Case Key Of
              #73 : PrecAide;  { PgUp }
              #81 : NextAide;  { PgDn }
            End
          Else
            If Key=#27 Then
              Begin
                AffMenu;
                SupPhase := SUPPHASE_MENUCHOIX;
              End;
      End;
    SUPPHASE_ACTCOM, SUPPHASE_ACTCOM2 :
      Begin
        If (Key<>#0) And WinSup.Active Then
          If Fnct Then
            Case Key Of
              #73,#72 : PrecCOM;  { PgUp }
              #81,#80 : NextCOM;  { PgDn }
            End
          Else
            Case Key Of
              #27 :
                Begin
                  AffMenu;
                  SupPhase := SUPPHASE_MENUCHOIX;
                End;
              #13 :
                If SupPhase=SUPPHASE_ACTCOM2 Then
                  Begin
                    If TabCom[NumCom].Wc<>Nil Then
                      Begin
                        If TabCom[NumCom].Wc^.Open Then
                          TabCom[NumCom].Wc^.Com.Done;
                        TabWin[NumCom].x := TabCom[NumCom].Wc^.Win.PlanX;
                        TabWin[NumCom].y := TabCom[NumCom].Wc^.Win.PlanY;
                        TabCom[NumCom].Wc^.Win.Done;
                        FreeMem(TabCom[NumCom].Wc,SizeOf(WinCom));
                        TabCom[NumCom].Wc := NIL;
                        AffMenu;
                        SupPhase := SUPPHASE_MENUCHOIX;
                      End;
                  End
                Else
                  Begin
                    If TabCom[NumCom].Wc<>Nil Then
                      Begin
                        TabCom[NumCom].Wc^.Win.Foreground;
                        AffMenu;
                        SupPhase := SUPPHASE_MENUCHOIX;
                      End
                    Else
                      If Not(GoodRegUART(TabCom[NumCom].RegUART)) Then
                        Begin
                          AffComRegUART;
                          SupPhase := SUPPHASE_ACTCOMUART;
                        End
                      Else
                        If TabCom[NumCom].ChxIrq=$FF Then
                          Begin
                            AffComChxIrq;
                            SupPhase := SUPPHASE_ACTCOMCHXIRQ;
                          End
                        Else
                          If CreatWinCom(NumCom) Then
                            Begin
                              AffMenu;
                              SupPhase := SUPPHASE_MENUCHOIX;
                            End;
                  End;
            End;
      End;
    SUPPHASE_ACTCOMUART :
      Begin
        If (Key<>#0) And WinSup.Active Then
          If Fnct Then
            Case Key Of
              #73 : PrecUART(8*8);
              #72 : PrecUART(8);
              #80 : NextUART(8);
              #81 : NextUART(8*8);
            End
          Else
            Case Key Of
              #27 :
                Begin
                  AffActiverCom;
                  SupPhase := SUPPHASE_ACTCOM;
                End;
              #13 :
                Begin
                  If GoodRegUART(RegUART) Then
                    Begin
                      TabCom[NumCom].RegUART := RegUART;
                      If TabCom[NumCom].ChxIrq<>$FF Then
                        Begin
                          If CreatWinCom(NumCom) Then
                            Begin
                              AffMenu;
                              SupPhase := SUPPHASE_MENUCHOIX;
                            End;
                        End
                      Else
                        Begin
                          AffComChxIrq;
                          SupPhase := SUPPHASE_ACTCOMCHXIRQ;
                        End;
                    End;
                End;
            End;
      End;
    SUPPHASE_ACTCOMCHXIRQ :
      Begin
        If (Key<>#0) And WinSup.Active Then
          If Fnct Then
            Case Key Of
              #73,#72 : PrecChxIrq;
              #80,#81 : NextChxIrq;
            End
          Else
            Case Key Of
              #27 :
                Begin
                  AffActiverCom;
                  SupPhase := SUPPHASE_ACTCOM;
                End;
              #13 :
                Begin
                  TabCom[NumCom].ChxIrq := ChxIrq;
                  If CreatWinCom(NumCom) Then
                    Begin
                      AffMenu;
                      SupPhase := SUPPHASE_MENUCHOIX;
                    End;
                End;
            End;
      End;
    SUPPHASE_QUIT :
      Begin
        If (Key<>#0) And WinSup.Active Then
          If Not(Fnct) Then
            Case UpCase(Key) Of
              #27,'N' :
                Begin
                  AffMenu;
                  SupPhase := SUPPHASE_MENUCHOIX;
                End;
              'O' :
                Begin
                  QuitSoft := TRUE;
                End;
            End;
      End;
  End;
End;


Procedure RefreshWc( Key : Char; Fnct : Boolean );
Var i : Byte;
Begin
  For i := 1 To MAXCOM Do
    If TabCom[i].Wc<>NIL Then RefreshWinCom(i,Key,Fnct);
End;


Procedure RefreshAll( Key : Char; Fnct : Boolean );
Begin
  RefreshSup(Key,Fnct);
  RefreshWc(Key,Fnct);
End;


Const TabALT1 : Array[16..25] Of Char = ('Q','W','E','R','T','Y','U','I','O','P');
      TabALT2 : Array[30..38] Of Char = ('A','S','D','F','G','H','J','K','L');
      TabALT3 : Array[44..50] Of Char = ('Z','X','C','V','B','N','M');

Function ScanALT(c : Char) : Byte;
Begin
  If c=#129 Then ScanALT := 0
  Else
    If (c>=#120) And (c<=#128) Then ScanALT := Byte(c)-119
    Else
      If (c>=#16) And (c<=#25) Then ScanALT := Byte(TabALT1[Byte(c)])-Byte('A')+10
      Else
        If (c>=#30) And (c<=#38) Then ScanALT := Byte(TabALT2[Byte(c)])-Byte('A')+10
        Else
          If (c>=#44) And (c<=#50) Then ScanALT := Byte(TabALT3[Byte(c)])-Byte('A')+10
          Else ScanALT := $FF;
End;


Procedure Main;
Var Key  : Word;
    c    : Char;
    Shift: Byte;
    Fnct : Boolean;
    KCd  : Byte;
    plan : PZXPlanRec Absolute CurrentEnablePlan;
    MoveOn : Boolean;
Begin
  MoveOn := FALSE;
  While Not(QuitSoft) Do
    Begin
      If CheckUpMode=CHECKUP_NIL Then CheckUp;

      If ZXKeyPressed Then
        Begin
          Key   := ZXReadKey;
          Shift := ZXShiftStatus;

          If (Shift And 3<>0) And (Lo(Key) In [46,48..57]) And
             (Hi(Key) In [71..73,75,77,79..83]) Then Byte(Key) := 0;

          If Lo(Key)=0 Then
            Begin
              Fnct := TRUE;
              c    := Char(Hi(Key));
            End
          Else
            Begin
              Fnct := FALSE;
              c    := Char(Lo(Key));
            End;

          If Fnct Then
            Begin
              KCd := ScanALT(c);
              If (KCd<>$FF) And (c<>#16) And (c<>#45) Then
                Begin
                  EnablePlan(KCd);
                  c := #0;
                End
              Else
                If CurrentEnablePlan<>NIL Then
                  Begin
                    If Shift And 3<>0 Then
                      Begin { mouvement souhait ? }
                        Case c Of
                          #72  : Begin { cur haut }
                                   If (plan^.y>0) Then
                                     MoveToPlan(plan,plan^.x,plan^.y-1);
                                   c := #0;
                                 End;
                          #75  : Begin { cur gauche }
                                   If (plan^.x>0) Then
                                     MoveToPlan(plan,plan^.x-1,plan^.y);
                                   c := #0;
                                 End;
                          #77  : Begin { cur droite }
                                   MoveToPlan(plan,plan^.x+1,plan^.y);
                                   c := #0;
                                 End;
                          #80  : Begin { cur bas }
                                   MoveToPlan(plan,plan^.x,plan^.y+1);
                                   c := #0;
                                 End;
                          #73  : Begin { PgUp }
                                   ForeSwapPlan(plan);
                                   c := #0;
                                 End;
                          #81  : Begin { PgDn }
                                   BackSwapPlan(plan);
                                   c := #0;
                                 End;
                          #132 : Begin { Ctrl+PgUp }
                                   ForegroundPlan(plan);
                                   c := #0;
                                 End;
                          #118 : Begin { Ctrl+PgDn }
                                   BackgroundPlan(plan);
                                   c := #0;
                                 End;
                        End;
                      End;

                    Case c Of
                      #106 : Begin  { ALT+F3  => desactive fentre }
                               DisablePlan;
                             End;
                    End;
                  End;
            End;
        End
      Else
        Begin
          c := #0;
          Fnct := FALSE;
        End;
      RefreshAll(c,Fnct);
    End;
End;


Var SaveExit : Pointer;

Procedure MyExit; Far;
Var i : Byte;
Begin
  ExitProc := SaveExit;

End;


Begin
  InitXSertest;
  InitZXPlan;

  SaveExit := ExitProc;
  ExitProc := @MyExit;

  If ChargeParam Then
    Begin
      If ((CheckUpMode=CHECKUP_XT) And Not(InstCheckUp(CheckUpSpeed))) Or
         ((CheckUpMode=CHECKUP_AT) And Not(InstCheckUpAT(CheckUpSpeed))) Then
        Begin
          Writeln('Impossible d''installer le "CheckUp"');
        End
      Else
        Begin
          OpenVideo;
          CurOff;
          CurBig;
          MakeVideoBack;

          Main;

          CloseVideo;

          KillCheckUpAT;
          KillCheckUp;
        End;
    End;
End.
