
Const INTVIDEO    = $10;

      VMODE_UNDEF = 0;      { mode indtermin (choix entre MDA ou CGA) }

      VMODE_MDA   = 1;
      VMODE_CGA   = 2;
      VMODE_EGA   = 3;      { EGA 43 lignes ou VGA 50 lignes }

      LastVideo   : Byte = 0;              { etat video au lancement }
      VideoMode   : Byte = VMODE_UNDEF;      { mode video voulu }
      VModeVGA    : Boolean = FALSE;       { TRUE=> EGA mais VGA !! }

      CBlckWht    : Boolean = FALSE;


      VIDEOSEG_MONO    = $B000;
      VIDEOSEG_COULEUR = $B800;

      VideoSeg    : Word = 0;

      NbColumns   : Word = 0;
      NbLines     : Word = 0;

      CCtrl       : Byte = 0;    { couleur ligne de contrle }

      CBack       : Byte = 0;    { couleur vide }
      CarBack     : Char = '';

      CBorder     : Byte = 0;    { couleur cadre   }
      CPlan       : Byte = 0;    { couleur du plan }
      CTitle      : Byte = 0;    { couleur titre   }
      CTextBlack  : Byte = 0;
      CTextDark   : Byte = 0;
      CTextGray   : Byte = 0;
      CTextWhite  : Byte = 0;
      CBackBlack  : Byte = 0;
      CBackGray   : Byte = 0;

{ -----ctrl----- }
{                }
{  windows...    }
{                }
{ -----ctrl----- }

Procedure OpenVideo;
Begin
  { lire le mode video courant }
  Asm
      MOV  AH, 0Fh
      INT  INTVIDEO
      MOV  [LastVideo], AL

      CMP  [VideoMode], VMODE_EGA
      JA   @ICI                        { mode video bizarre ... }
      CMP  [VideoMode], VMODE_UNDEF
      JNE  @CONT
  @ICI:
      { dterminer le mode video entre MDA et CGA }
      INT  11h
      AND  AL, 00110000b
      CMP  AL, 00110000b
      JNE  @CARTE_CGA
      MOV  [VideoMode], VMODE_MDA
      JMP  @CONT
  @CARTE_CGA:
      MOV  [VideoMode], VMODE_CGA
  @CONT:
      MOV  [CCtrl], 70h            { dfinir noir & blanc }
      MOV  [CBack], 07h
      MOV  [CBorder], 0Fh
      MOV  [CPlan], 07h
      MOV  [CTitle], 70h
      MOV  [CTextBlack], 00h
      MOV  [CTextDark], 08h
      MOV  [CTextGray], 07h
      MOV  [CTextWhite], 0Fh
      MOV  [CBackBlack], 00h
      MOV  [CBackGray], 70h

      MOV  [NbColumns], 80         { quelque soit le mode }
      CMP  [VideoMode], VMODE_MDA
      JNE  @COULEUR

      MOV  [VideoSeg], 0B000h

      MOV  [NbLines], 25
      MOV  AX, 0007h               { mode MDA }
      JMP  @FIXEMODE
  @COULEUR:
      MOV  [VideoSeg], 0B800h

      CMP  [CBlckWht], FALSE
      JNE  @NOCOLOR

      MOV  [CCtrl], 70h
      MOV  [CBack], 31h
      MOV  [CBorder], 1Fh
      MOV  [CPlan], 1Eh
      MOV  [CTitle], 4Eh
      MOV  [CTextBlack], 01h
      MOV  [CTextDark], 03h
      MOV  [CTextGray], 0Ah
      MOV  [CTextWhite], 0Eh
      MOV  [CBackBlack], 10h
      MOV  [CBackGray], 70h

  @NOCOLOR:
      CMP  [VideoMode], VMODE_CGA
      JNE  @EGA

      MOV  [NbLines], 25
      MOV  AX, 0003h          { mode couleur CGA }
      JMP  @FIXEMODE
  @EGA:
      MOV  AX, 1A00h
      INT  INTVIDEO           { dterminer le type de carte }
      CMP  AL, 1Ah
      JE   @VGA

      MOV  [VModeVGA], FALSE    { car vrai EGA }
      MOV  [NbLines], 43
      MOV  AX, 1112h
      XOR  BL, BL
      JMP  @FIXEMODE
  @VGA:
      MOV  [VModeVGA], TRUE     { car mode EGA mais en fait VGA }
      MOV  [NbLines], 50
      MOV  AX, 1112h
      XOR  BL, BL
  @FIXEMODE:
      INT  INTVIDEO
  End;
End;


Procedure CloseVideo; Assembler;
Asm
    MOV  AH, 00h
    MOV  AL, [LastVideo]
    INT  INTVIDEO
End;


Procedure MakeVideoBack; Assembler;
Asm
    CLD
    MOV  ES, [VideoSeg]
    XOR  DI, DI
    MOV  AL, ' '
    MOV  AH, [CCtrl]
    MOV  CX, [NbColumns]
    REP  STOSW

    MOV  AX, [NbLines]
    SUB  AX, 2
    MUL  [NbColumns]
    MOV  CX, AX
    MOV  AL, [CarBack]
    MOV  AH, [CBack]
    REP  STOSW

    MOV  AL, ' '
    MOV  AH, [CCtrl]
    MOV  CX, [NbColumns]
    REP  STOSW
End;



Procedure CurOFF; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    OR   CH, 00100000b    { bit 5-6 = 01 => invisible }
    INT  INTVIDEO
End;


Procedure CurON; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    INT  INTVIDEO
End;


Procedure CurSmall; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    AND  CH, 11100000b    { garder bit5  7 }
    AND  CL, 11100000b
    CMP  [VideoMode], VMODE_MDA
    JNE  @ICI
    OR   CH, 11           { ligne de debut }
    OR   CL, 12           { ligne fin }
    JMP  @SETCUR
@ICI:
    OR   CH, 6            { ligne de debut }
    OR   CL, 7            { ligne fin }
@SETCUR:
    MOV  AH, 01h
    INT  INTVIDEO
End;


Procedure CurBig; Assembler;
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    AND  CH, 11100000b    { garder bit5  7 }
    AND  CL, 11100000b
    CMP  [VideoMode], VMODE_MDA
    JNE  @ICI
    OR   CH, 0            { ligne de debut }
    OR   CL, 13           { ligne fin }
    JMP  @SETCUR
@ICI:
    OR   CH, 0            { ligne de debut }
    OR   CL, 7            { ligne fin }
@SETCUR:
    MOV  AH, 01h
    INT  INTVIDEO
End;


Procedure CurPos( column, row : Byte ); Assembler;
Asm
    MOV  AH, 02h
    MOV  DL, column
    MOV  DH, row
    XOR  BH, BH
    INT  INTVIDEO
End;


Const ZXPLANATTR_WINDOW = 1;
      ZXPLANATTR_CURON  = 2;

Type ZXPlanName = String[16];

     PZXPlanRec = ^ZXPlanRec;

     ZXPlanRec = Record
         Name     : ZXPlanName;
         Attr     : Byte;       { attribut du plan }
         x        : Byte;
         y        : Byte;
         Lg       : Byte;
         Ht       : Byte;
         CurX     : Byte;       { position du curseur (relative) }
         CurY     : Byte;
         Prior    : ShortInt;   { priorit du plan (0=>normal) }
         CodeKey  : Byte;       { n touche d'appel ($FF=>aucune) }
         Back     : Pointer;
         NbLap    : Word;       { nombre de plan  verifier      }
         FirstLap : PZXPlanRec; { premier plan                   }
         Prec     : PZXPlanRec;
         Next     : PZXPlanRec;
       End;

    

Const FirstPlan         : PZXPlanRec = Nil;
      LastPlan          : PZXPlanRec = Nil;
      NbPlan            : Word = 0;

      CurrentEnablePlan : PZXPlanRec = Nil;

      { nombre de CodeKey max }

      NbCodeKey = 10;

      LgFatCodeKey = (NbCodeKey+7) Div 8;

      { table des allocations de codes }

Var FatCodeKey : Array[0..LgFatCodeKey-1] Of Byte;


Function  AllocCodeKey : Byte;
Var i, j, b : Byte;
Begin
  i := 0;
  While (i<LgFatCodeKey) Do
    If FatCodeKey[i]<>255 Then
      Begin
        b := FatCodeKey[i];
        j := 0;
        While (j<8) Do
          If (b Shr j) And 1=0 Then
            Begin
              b := b Or (1 Shl j);
              FatCodeKey[i] := b;
              AllocCodeKey := (i*8)+j+1;
              Exit;
            End
          Else inc(j);
      End
    Else Inc(i);
  AllocCodeKey := 0;
End;


Procedure FreeCodeKey( ck : Byte );
Var i : Byte;
Begin
  If ck<>$FF Then
    Begin
      i := (ck-1) Div 8;
      FatCodeKey[i] := FatCodeKey[i] And Not(1 Shl ((ck-1) And 7));
    End;
End;


Function  CodeKey2ASCII( ck : Byte ) : Char;
Begin
  If ck=$FF Then CodeKey2ASCII := #0
  Else
    If ck<=9 Then CodeKey2ASCII := Char(Byte('0')+ck)
    Else
      CodeKey2ASCII := Char(Byte('A')+(ck-10));
End;


Procedure InitZXPlan;
Var i : Word;
Begin
  For i := 0 To LgFatCodeKey-1 Do FatCodeKey[i] := 0;
End;


Function FindForeground( Prior : Shortint ) : PZXPlanRec;
Var p : PZXPlanRec;
Begin
  p := LastPlan;
  While (p<>Nil) And (p^.Prior>Prior) Do p := p^.Prec;
  FindForeground := p;
End;


Function FindBackground( Prior : Shortint ) : PZXPlanRec;
Var p : PZXPlanRec;
Begin
  p := LastPlan;
  While (p<>Nil) And (p^.Prior>Prior) Do p := p^.Prec;
  While (p<>Nil) And (p^.Prior=Prior) Do p := p^.Prec;
  FindBackground := p;
End;


Function FindForeSwap( plan : PZXPlanRec ) : PZXPlanRec;
{ recherche la page devant, de priorit egale }
Begin
  If (plan^.Next<>NIL) And (plan^.Next^.Prior=plan^.Prior) Then
    FindForeSwap := plan^.Next
  Else FindForeSwap := plan;
End;


Function FindBackSwap( plan : PZXPlanRec ) : PZXPlanRec;
Begin
  If (plan^.Prec<>NIL) And (plan^.Prec^.Prior=plan^.Prior) Then
    FindBackSwap := plan^.Prec^.Prec
  Else FindBackSwap := plan^.Prec;
End;


{ initialise les "ombres" entre fentres ...               }
{ en fait, dfinie quel fentre recouvre tel autre etc...  }
{ cela ne sert qu' accelerer l'ecriture ou lecture        }
{ une fenetre qui n'est pas recouverte s'affiche trs vite }

Function Shadow( plan, p : PZXPlanRec ) : Boolean;
Begin
  Shadow := (p^.x<plan^.x+plan^.lg) And
            (p^.x+p^.lg>plan^.x) And
            (p^.y<plan^.y+plan^.ht) And
            (p^.y+p^.ht>plan^.y);
End;


Procedure InitShadow;
Var plan, p : PZXPlanRec;
    NbP  : Word;
    i      : Word;
Begin
  NbP := NbPlan;
  plan := FirstPlan;
  While plan<>Nil Do
    Begin
      Dec(NbP);
      i := NbP;
      { cherche le premier recouvrement }
      p := plan^.Next;
      While (p<>Nil) And Not(Shadow(plan,p)) Do
        Begin
          p := p^.Next;
          Dec(i);
        End;

      If p<>Nil Then
        Begin
          plan^.FirstLap := p;

          { cherche le dernier recouvrement }
          p := LastPlan;
          While Not(Shadow(plan,p)) Do
            Begin
              p := p^.Prec;
              Dec(i);
            End;
          plan^.NbLap := i;
        End
      Else
        Begin
          plan^.NbLap    := 0;
          plan^.FirstLap := NIL;
        End;

      plan := plan^.Next;
    End;
End;


Procedure InsertPlan( PrecPlan, NewPlan : PZXPlanRec );
Var p, plan : PZXPlanRec;
Begin
  p   := PrecPlan;
  plan := NewPlan;

  { s'inserer devant "p" }
  If p=Nil Then
    Begin  { premier lment }
      plan^.Prec := NIL;
      plan^.Next := FirstPlan;

      If LastPlan=NIL Then LastPlan := NewPlan
      Else FirstPlan^.Prec := NewPlan;

      FirstPlan := NewPlan;
    End
  Else
    Begin
      plan^.Prec := p;
      If p^.Next=NIL Then
        Begin
          plan^.Next  := NIL;
          LastPlan := NewPlan;
        End
      Else
        Begin
          plan^.Next := p^.Next;
          p^.Next^.Prec := NewPlan;
        End;
      p^.Next := NewPlan;
    End;

  Inc(NbPlan);
End;


Procedure DeletePlan( plan : PZXPlanRec );
Begin
  If plan^.Prec=NIL Then FirstPlan := plan^.Next
  Else plan^.Prec^.Next := plan^.Next;
  If plan^.Next=NIL Then LastPlan := plan^.Prec
  Else plan^.Next^.Prec := plan^.Prec;

  Dec(NbPlan);
End;



Function WritePlan( plan : PZXPlanRec; data : Word; rx, ry : Word ) : Word;
Type PtrRec = Record Ofs, Seg : Word; End;
Var p   : PZXPlanRec;
    bck : ^Word;
    i   : Word;
Begin
  If (rx<plan^.Lg) And (ry<plan^.Ht) Then
    Begin
      Inc(ry,plan^.y);
      Inc(rx,plan^.x);

      p := plan^.FirstLap;

      For i := 1 To plan^.NbLap Do
        Begin
          If (p^.x<=rx) And (p^.x+p^.Lg>rx) And
             (p^.y<=ry) And (p^.y+p^.Ht>ry) Then
            Begin
              bck := Ptr(PtrRec(p^.Back).Seg,
                         PtrRec(p^.Back).Ofs+((ry-p^.y)*p^.lg+(rx-p^.x))*2);
              WritePlan := bck^;
              bck^ := data;
              Exit;
            End;
          p := p^.Next;
        End;
      WritePlan := MemW[VideoSeg:((ry+1)*NbColumns+rx)*2];
      MemW[VideoSeg:((ry+1)*NbColumns+rx)*2] := data;
    End;
End;


Procedure BackwardPlan( plan : PZXPlanRec );
Type PtrRec = Record Ofs, Seg : Word; End;
Var bck : ^Word;
    i   : Word;
    j   : Word;
Begin
  bck := plan^.Back;
  For i := 0 To plan^.Ht-1 Do
    For j := 0 To plan^.Lg-1 Do
      Begin
        bck^ := WritePlan(plan,bck^,j,i);
        Inc(PtrRec(bck).Ofs,2);
      End;
End;


Function ReadPlan( plan : PZXPlanRec; rx, ry : Word ) : Word;
Type PtrRec = Record Ofs, Seg : Word; End;
Var p  : PZXPlanRec;
    i  : Word;
Begin
  If (rx<plan^.Lg) And (ry<plan^.Ht) Then
    Begin
      Inc(ry,plan^.y);
      Inc(rx,plan^.x);

      p := plan^.FirstLap;
      For i := 1 To plan^.NbLap Do
        Begin
          If (p^.x<=rx) And (p^.x+p^.Lg>rx) And
             (p^.y<=ry) And (p^.y+p^.Ht>ry) Then
            Begin
              ReadPlan := Word(Ptr(PtrRec(p^.Back).Seg,
                                   PtrRec(p^.Back).Ofs+((ry-p^.y)*p^.lg+(rx-p^.x))*2)^);
              Exit;
            End;
          p := p^.Next;
        End;
      ReadPlan := MemW[VideoSeg:((ry+1)*NbColumns+rx)*2];
    End;
End;


Function VisiblePlan( plan : PZXPlanRec; rx, ry : Word ) : Boolean;
Var p   : PZXPlanRec;
    i   : Word;
Begin
  If (rx<plan^.Lg) And (ry<plan^.Ht) Then
    Begin
      Inc(ry,plan^.y);
      Inc(rx,plan^.x);

      p := plan^.FirstLap;
      For i := 1 To plan^.NbLap Do
        Begin
          If (p^.x<=rx) And (p^.x+p^.Lg>rx) And
             (p^.y<=ry) And (p^.y+p^.Ht>ry) Then
            Begin
              VisiblePlan := FALSE;
              Exit;
            End;
          p := p^.Next;
        End;
      VisiblePlan := TRUE;
    End
  Else VisiblePlan := FALSE;
End;


Procedure ScrollUpPlan( plan : PZXPlanRec;
                        rx, ry, rLg, rHt, How, Attr : Byte );
Type WordRec = Record Lo, Hi : Byte; End;
Var data : Word;
    x, y : Byte;
    r    : Word;
Begin
  If (rx+rLg<=plan^.Lg) And (ry+rHt<plan^.Ht) Then
    If plan^.NbLap=0 Then
      Begin  { emploi direct du DOS }
        Asm
            LES  DI, plan
            MOV  CL, [ES:DI+ZXPlanRec.x]
            ADD  CL, rx
            MOV  CH, [ES:DI+ZXPlanRec.y]
            ADD  CH, ry
            INC  CH

            MOV  DL, CL
            ADD  DL, rLg
            DEC  DL

            MOV  DH, CH
            ADD  DH, rHt
            DEC  DH

            MOV  AH, 06h
            MOV  AL, How
            MOV  BH, Attr
            INT  INTVIDEO
        End;
      End
    Else
      Begin
        If (How=0) Or (How>rHt) Then How := rHt;

        For r := 1 To How Do
          For x := rx To rx+rLg-1 Do
            Begin
              WordRec(data).Hi := Attr;
              WordRec(data).Lo := Byte(' ');

              y := ry+rHt+(How-r);
              Repeat
                Dec(y,How);
                data := WritePlan(plan,data,x,y);
              Until y<How+ry;
            End;
      End;
End;



Procedure ScrollDownPlan( plan : PZXPlanRec;
                          rx, ry, rLg, rHt, How, Attr : Byte );
Type WordRec = Record Lo, Hi : Byte; End;
Var data : Word;
    x, y : Byte;
    r    : Word;
Begin
  If (rx+rLg<=plan^.Lg) And (ry+rHt<plan^.Ht) Then
    If plan^.NbLap=0 Then
      Begin  { emploi direct du DOS }
        Asm
            LES  DI, plan
            MOV  CL, [ES:DI+ZXPlanRec.x]
            ADD  CL, rx
            MOV  CH, [ES:DI+ZXPlanRec.y]
            ADD  CH, ry
            INC  CH

            MOV  DL, CL
            ADD  DL, rLg
            DEC  DL

            MOV  DH, CH
            ADD  DH, rHt
            DEC  DH

            MOV  AH, 07h
            MOV  AL, How
            MOV  BH, Attr
            INT  INTVIDEO
        End;
      End
    Else
      Begin
        If (How=0) Or (How>rHt) Then How := rHt;

        For r := 1 To How Do
          For x := rx To rx+rLg-1 Do
            Begin
              WordRec(data).Hi := Attr;
              WordRec(data).Lo := Byte(' ');

              y := ry;
              Repeat
                data := WritePlan(plan,data,x,y);
                Inc(y,How);
              Until y>=ry+rHt+(How-r);
            End;
      End;
End;


Type ZXWindowBorder = Record
         c1 : Char;
         c2 : Char;
         c3 : Char;
         c4 : Char;
         h  : Char;
         v  : Char;
       End;

    
Const BorderFat : ZXWindowBorder = ( c1:''; c2:''; c3:''; c4:''; h:''; v:'' );
      BorderTiny: ZXWindowBorder = ( c1:''; c2:''; c3:''; c4:''; h:''; v:'' );


Procedure DisplayWindowBorder( plan : PZXPlanRec; Var Border : ZXWindowBorder );
Type WordRec = Record Lo, Hi : Byte; End;
Var i : Word;
    data : Word;
Begin
  WordRec(data).Hi := CBorder;
  WordRec(data).Lo := Byte(Border.c1);
  WritePlan(plan,data,0,0);
  WordRec(data).Lo := Byte(Border.h);
  For i := 1 To plan^.Lg-2 Do WritePlan(plan,data,i,0);
  WordRec(data).Lo := Byte(Border.c2);
  WritePlan(plan,data,plan^.Lg-1,0);
  WordRec(data).Lo := Byte(Border.v);
  For i := 1 To plan^.Ht-2 Do WritePlan(plan,data,plan^.Lg-1,i);
  WordRec(data).Lo := Byte(Border.c3);
  WritePlan(plan,data,plan^.Lg-1,plan^.Ht-1);
  WordRec(data).Lo := Byte(Border.h);
  For i := plan^.Lg-2 Downto 1 Do WritePlan(plan,data,i,plan^.Ht-1);
  WordRec(data).Lo := Byte(Border.c4);
  WritePlan(plan,data,0,plan^.Ht-1);
  WordRec(data).Lo := Byte(Border.v);
  For i := plan^.Ht-2 Downto 1 Do WritePlan(plan,data,0,i);
End;


Procedure DisplayWindowTitle( plan : PZXPlanRec );
Type WordRec = Record Lo, Hi : Byte; End;
Var data : Word;
    LgTitle : Byte;
    sPos : Byte;
    i    : Word;
Begin
  WordRec(data).Hi := CTitle;

  LgTitle := Length(plan^.Name);
  While (LgTitle>0) And (4+2+LgTitle>plan^.Lg) Do Dec(LgTitle);

  If LgTitle=0 Then
    Begin  { ecrire la touche d'appel }
      sPos := plan^.Lg Div 2;
      WordRec(data).Lo := Byte(CodeKey2ASCII(plan^.CodeKey));
      WritePlan(plan,data,sPos,0);
    End
  Else
    Begin
      sPos := (plan^.Lg-(2+4+LgTitle)) Div 2 +1;
      WordRec(data).Lo := Byte(' ');
      WritePlan(plan,data,sPos,0);
      Inc(sPos);
      For i := 1 To LgTitle Do
        Begin
          WordRec(data).Lo := Byte(plan^.Name[i]);
          WritePlan(plan,data,sPos,0);
          Inc(sPos);
        End;
      WordRec(data).Lo := Byte(' ');
      WritePlan(plan,data,sPos,0);
      WordRec(data).Lo := Byte(CodeKey2ASCII(plan^.CodeKey));
      WritePlan(plan,data,sPos+2,0);
      WordRec(data).Lo := Byte('');
      WordRec(data).Hi := CBorder;
      WritePlan(plan,data,sPos+1,0);
    End;
End;


Procedure DisplayWindowFrame( plan : PZXPlanRec );
Begin
  If plan^.Attr And ZXPLANATTR_WINDOW<>0 Then
    Begin
      If CurrentEnablePlan=plan Then DisplayWindowBorder(plan,BorderFat)
      Else DisplayWindowBorder(plan,BorderTiny);

      DisplayWindowTitle(plan);
    End;
End;


{  appeller qu'en cas de changement de mode curseur }
{ ou de passage enable/disable }

Procedure UpDateCursorMode( plan : PZXPlanRec );
Begin
  If CurrentEnablePlan=plan Then
    Begin
      If (plan^.Attr And ZXPLANATTR_CURON<>0) And
         VisiblePlan(plan,plan^.CurX,plan^.CurY) Then CurOn
      Else CurOff;
    End
  Else If CurrentEnablePlan=NIL Then CurOff;
End;


{  appeller qu'en cas de changement de position du curseur }

Procedure UpDateCursorXY( plan : PZXPlanRec );
Begin
  If CurrentEnablePlan=plan Then
    Begin
      If (plan^.Attr And ZXPLANATTR_CURON<>0) Then
        Begin
          CurPos(plan^.x+plan^.CurX,plan^.y+plan^.CurY+1);
          If VisiblePlan(plan,plan^.CurX,plan^.CurY) Then CurOn
          Else CurOff;
        End
      Else CurOff;
    End
  Else If CurrentEnablePlan=NIL Then CurOff;
End;


Procedure CursorPlanMode( plan : PZXPlanRec; CurOn : Boolean );
Begin
  If CurOn Then plan^.Attr := plan^.Attr Or (ZXPLANATTR_CURON)
  Else plan^.Attr := plan^.Attr And Not(ZXPLANATTR_CURON);
  UpDateCursorXY(plan);
End;


Procedure DisablePlan;
Var p : PZXPlanRec;
Begin
  If CurrentEnablePlan<>NIL Then
    Begin
      p := CurrentEnablePlan;
      CurrentEnablePlan := NIL;
      DisplayWindowFrame(p);
      UpDateCursorMode(p);
    End;
End;


Procedure MoveToPlan( plan : PZXPlanRec; x, y : Byte );
Begin
  If (x+plan^.Lg<=NbColumns) And (y+plan^.Ht<=NbLines-2) Then
    Begin
      BackwardPlan(plan);

      plan^.x := x;
      plan^.y := y;

      InitShadow;

      BackwardPlan(plan);

      UpDateCursorXY(plan);
    End;
End;


Procedure ForegroundPlan( plan : PZXPlanRec );
Var p : PZXPlanRec;
Begin
  p := FindForeground(plan^.Prior);

  If p<>plan Then
    Begin
      BackwardPlan(plan);

      DeletePlan(plan);

      InsertPlan(p,plan);

      InitShadow;

      BackwardPlan(plan);

      UpDateCursorMode(plan);
    End;
End;


Procedure BackgroundPlan( plan : PZXPlanRec );
Var p : PZXPlanRec;
Begin
  p := FindBackground(plan^.Prior);

  If p<>plan^.Prec Then
    Begin
      BackwardPlan(plan);

      DeletePlan(plan);

      InsertPlan(p,plan);

      InitShadow;

      BackwardPlan(plan);

      UpDateCursorMode(plan);
    End;
End;



Procedure ForeSwapPlan( plan : PZXPlanRec );
Var p : PZXPlanRec;
Begin
  p := FindForeSwap(plan);

  If p<>plan Then
    Begin
      BackwardPlan(plan);

      DeletePlan(plan);

      InsertPlan(p,plan);

      InitShadow;

      BackwardPlan(plan);

      UpDateCursorMode(plan);
    End;
End;


Procedure BackSwapPlan( plan : PZXPlanRec );
Var p : PZXPlanRec;
Begin
  p := FindBackSwap(plan);

  If plan^.Prec<>p Then
    Begin
      BackwardPlan(plan);

      DeletePlan(plan);

      InsertPlan(p,plan);

      InitShadow;

      BackwardPlan(plan);

      UpDateCursorMode(plan);
    End;
End;



Function EnablePlan( CodeKey : Byte ) : Boolean;
Var p : PZXPlanRec;
Begin
  If CodeKey<>$FF Then
    Begin
      p := FirstPlan;
      While p<>NIL Do
        If p^.CodeKey=CodeKey Then
          Begin
            DisablePlan;  { l'ancien }
            CurrentEnablePlan := p;  { nouveau }
            ForegroundPlan(p);
            DisplayWindowFrame(p);
            UpDateCursorXY(p);
            EnablePlan := TRUE;
            Exit;
          End
        Else p := p^.Next;
    End;
  EnablePlan := FALSE;
End;


{*********************************
 *                               *
 *     L'objet PLAN              *
 *                               *
 *********************************}

Type PZXPlanCfg = ^ZXPlanCfg;

     ZXPlanCfg = Record
         Name         : ZXPlanName;  { nom du plan }
         x, y, Lg, Ht : Byte;        { situation de la fentre }
         CodeKey      : Byte;        { code d'appel $FF =>aucun }
         Prior        : ShortInt;    { priorit }
         Background   : Boolean;     { TRUE=> mise en background automatique }
         Enable       : Boolean;     { TRUE=> directement activ }
       End;

     PZXPlan = ^ZXPlan;

     ZXPlan = Object
         plan     : PZXPlanRec;
         Lg, Ht   : Byte;         { copie de la taille du plan }

         Constructor Init( Cfg : PZXPlanCfg );
         Destructor Done;
         Function  Poke( data : Word; rx, ry : Byte ) : Word;
         Function  Peek( rx, ry : Byte ) : Word;
         Procedure MoveTo( x, y : Byte );
         Function  PlanX : Byte;
         Function  PlanY : Byte;
         Procedure Foreground;
         Procedure Background;
         Procedure ForeSwap;
         Procedure BackSwap;
         Function  SetPriority( NewPrior : Shortint ) : Word;
         Function  GetPriority : Shortint;
         Function  GetCodeKey : Byte;
         Procedure ScrollUp( rx, ry, rLg, rHt, How, Attr : Byte );
         Procedure ScrollDown( rx, ry, rLg, rHt, How, Attr : Byte );
         Procedure Enable;
         Procedure Disable;
         Procedure Cursor( CurOn : Boolean );
         Procedure GotoXY( rx, ry : Byte );
         Function  WhereX : Byte;
         Function  WhereY : Byte;
       End;


Constructor ZXPlan.Init( Cfg : PZXPlanCfg );
Type PtrRec = Record Ofs, Seg : Word; End;
     WordRec = Record Lo, Hi : Byte; End;
Var i, j : Word;
    bck  : ^Word;
    Find : Boolean;
    p    : PZXPlanRec;
    b    : Byte;
    data : Word;
Begin
  If (Cfg=Nil) Then Fail;

  { verifie la possiblit d'ouverture }

  If (Cfg^.Lg=0) or (Cfg^.Ht=0) Then Fail;
  If (Cfg^.x+Cfg^.Lg>NbColumns) Then Cfg^.x := NbColumns-Cfg^.Lg;
  If (Cfg^.y+Cfg^.Ht>NbLines-2) Then Cfg^.y := NbLines-2-Cfg^.Ht;

  (*
  If (Cfg^.x+Cfg^.Lg>NbColumns) or (Cfg^.y+Cfg^.Ht>NbLines-2) Then Fail;
  *)

  GetMem(plan, SizeOf(ZXPlanRec));
  If plan=NIL Then Fail;

  GetMem(plan^.Back,(Cfg^.Ht*Cfg^.Lg)*2);
  If plan^.Back=NIL Then
    Begin
      FreeMem(plan,SizeOf(ZXPlanRec));
      Fail;
    End;

  plan^.Name    := Cfg^.Name;
  plan^.Attr    := 0;
  plan^.x       := Cfg^.x;
  plan^.y       := Cfg^.y;
  plan^.Lg      := Cfg^.Lg;
  plan^.Ht      := Cfg^.Ht;
  plan^.CurX    := 0;
  plan^.CurY    := 0;
  plan^.Prior   := Cfg^.Prior;

  plan^.CodeKey := Cfg^.CodeKey;
  (*
  plan^.CodeKey := AllocCodeKey;  { par dfaut }
  *)

  Lg            := plan^.Lg;
  Ht            := plan^.Ht;

  If Cfg^.Background Then InsertPlan(FindBackground(plan^.Prior),plan)
  Else InsertPlan(FindForeground(plan^.Prior),plan);

  InitShadow;

  WordRec(data).Lo := Byte(' ');
  WordRec(data).Hi := CPlan;

  bck := plan^.Back;
  For i := 0 To Cfg^.Ht-1 Do
    For j := 0 To Cfg^.Lg-1 Do
      Begin
        bck^ := WritePlan(plan,data,j,i);
        Inc(PtrRec(bck).Ofs,2);
      End;

  If Cfg^.Enable Then Enable;

End;


Destructor ZXPlan.Done;
Type PtrRec = Record Ofs, Seg : Word; End;
Var bck : ^Word;
    i   : Word;
    j   : Word;
Begin
  If CurrentEnablePlan=plan Then DisablePlan;

  bck := plan^.Back;
  For i := 0 To plan^.Ht-1 Do
    For j := 0 To plan^.Lg-1 Do
      Begin
        Poke(bck^,j,i);
        Inc(PtrRec(bck).Ofs,2);
      End;

  (*
  FreeCodeKey(plan^.CodeKey);
  *)

  DeletePlan(plan);

  InitShadow;

  FreeMem(plan^.Back,plan^.ht*plan^.lg*2);
  FreeMem(plan,SizeOf(ZXPlanRec));
End;


Function  ZXPlan.Poke( data : Word; rx, ry : Byte ) : Word;
Begin
  Poke := WritePlan(plan,data,rx,ry);
End;


Function ZXPlan.Peek( rx, ry : Byte ) : Word;
Begin
  Peek := ReadPlan(plan,rx,ry);
End;


Procedure ZXPlan.MoveTo( x, y : Byte );
Begin
  MoveToPlan(plan,x,y);
End;


Function  ZXPlan.PlanX : Byte;
Begin
  PlanX := plan^.x;
End;
 

Function  ZXPlan.PlanY : Byte;
Begin
  PlanY := plan^.y;
End;


Procedure ZXPlan.Foreground;
Begin
  ForegroundPlan(plan);
End;


Procedure ZXPlan.Background;
Begin
  BackgroundPlan(plan);
End;


Procedure ZXPlan.ForeSwap;
Begin
  ForeSwapPlan(plan);
End;


Procedure ZXPlan.BackSwap;
Begin
  BackSwapPlan(plan);
End;


Function  ZXPlan.SetPriority( NewPrior : Shortint ) : Word;
Begin
  SetPriority := plan^.Prior;
  plan^.Prior := NewPrior;

  BackwardPlan(plan);

  DeletePlan(plan);

  InsertPlan(FindForeground(NewPrior),plan);

  InitShadow;

  BackwardPlan(plan);
End;


Function  ZXPlan.GetPriority : Shortint;
Begin
  GetPriority := plan^.Prior;
End;


Function  ZXPlan.GetCodeKey : Byte;
Begin
  GetCodeKey := plan^.CodeKey;
End;


Procedure ZXPlan.ScrollUp( rx, ry, rLg, rHt, How, Attr : Byte );
Begin
  ScrollUpPlan(plan,rx,ry,rLg,rHt,How,Attr);
End;


Procedure ZXPlan.ScrollDown( rx, ry, rLg, rHt, How, Attr : Byte );
Begin
  ScrollDownPlan(plan,rx,ry,rLg,rHt,How,Attr);
End;


Procedure ZXPlan.Enable;
Begin
  EnablePlan(plan^.CodeKey);
End;


Procedure ZXPlan.Disable;
Begin
  If CurrentEnablePlan=plan Then DisablePlan;
End;


Procedure ZXPlan.Cursor( CurOn : Boolean );
Begin
  CursorPlanMode(plan,CurOn);
End;


Procedure ZXPlan.GotoXY( rx, ry : Byte );
Begin
  If rx<Lg Then plan^.CurX := rx;
  If ry<Ht Then plan^.CurY := ry;
  UpDateCursorXY(plan);
End;


Function  ZXPlan.WhereX : Byte;
Begin
  WhereX := plan^.CurX;
End;


Function  ZXPlan.WhereY : Byte;
Begin
  WhereY := plan^.CurY;
End;


Type ZXWindow = Object( ZXPlan )
         CurX, CurY : Byte;        { colle  la position rl }
         TextAttr   : Byte;
         RollOn     : Boolean;

         Constructor Init( Var Cfg : ZXPlanCfg );
         Destructor Done;
         Procedure GotoXY( cx, cy : Byte );
         Function  WhereX : Byte;
         Function  WhereY : Byte;
         Function  GetMaxX : Byte;
         Function  GetMaxY : Byte;

         Procedure Roll( ROn : Boolean );
         Procedure ScrollUp( How : Byte );
         Procedure ScrollDown( How : Byte );

         Procedure HighVideo;
         Procedure LowVideo;
         Procedure NormVideo;
         Procedure SetColor( c : Byte );

         Procedure Bell;
         Procedure Backspace;
         Procedure Linefeed;
         Procedure CarriageReturn;
         Procedure ClrEol;
         Procedure ClrScr;
         Procedure DelLine;
         Procedure InsLine;
         Procedure DirectChar( cx, cy : Byte; c : Char );
         Procedure DirectWrite( cx, cy : Byte; Text : String );
         Procedure WriteChar( c : Char );
         Procedure Write( s : String );
         Procedure WriteLn( s : String );
         Function  Active : Boolean;
       End;

Const { couleur avec "SetColor" }

      TextBlack  = 0;
      TextDark   = 1;
      TextGray   = 2;
      TextWhite  = 3;

      BackBlack  = 0;
      BackGray   = 4;

      TextBlink  = 8;

Constructor ZXWindow.Init( Var Cfg : ZXPlanCfg );
Begin
  If (Cfg.Lg<3) Or (Cfg.Ht<3) Or
     Not(ZXPlan.Init( @Cfg )) Then Fail;

  TextAttr := CTextWhite+CBackBlack;
  RollOn   := TRUE;

  plan^.Attr := plan^.Attr Or ZXPLANATTR_WINDOW;   { signale une fentre }

  DisplayWindowFrame(plan);
  GotoXY(1,1);
End;


Destructor ZXWindow.Done;
Begin
  ZXPlan.Done;
End;


Procedure ZXWindow.GotoXY( cx, cy : Byte );
Begin
  If (cx>0) And (cx<Lg-1) Then CurX := cx;
  If (cy>0) And (cy<Ht-1) Then CurY := cy;
  ZXPlan.GotoXY(CurX,CurY);
End;


Function  ZXWindow.WhereX : Byte;
Begin
  WhereX := CurX;
End;


Function  ZXWindow.WhereY : Byte;
Begin
  WhereY := CurY;
End;


Function  ZXWindow.GetMaxX : Byte;
Begin
  GetMaxX := Lg-2;
End;


Function  ZXWindow.GetMaxY : Byte;
Begin
  GetMaxY := Ht-2;
End;


Procedure ZXWindow.Roll( ROn : Boolean );
Begin
  RollOn := ROn;
End;


Procedure ZXWindow.ScrollUp( How : Byte );
Begin
  ZXPlan.ScrollUp(1,1,Lg-2,Ht-2,How,TextAttr);
End;


Procedure ZXWindow.ScrollDown( How : Byte );
Begin
  ZXPlan.ScrollDown(1,1,Lg-2,Ht-2,How,TextAttr);
End;


Procedure ZXWindow.Bell;
Begin
End;


Procedure ZXWindow.Backspace;
Begin
  If CurX>1 Then
    Begin
      Dec(CurX);
      ZXPlan.GotoXY(CurX,CurY);
    End;
End;


Procedure ZXWindow.Linefeed;
Begin
  Inc(CurY);
  If CurY>=Ht-1 Then
    If RollOn Then
      Begin
        CurY := Ht-2;
        ScrollUp(1);
      End
    Else CurY := 1;
  ZXPlan.GotoXY(CurX,CurY);
End;


Procedure ZXWindow.CarriageReturn;
Begin
  CurX := 1;
  ZXPlan.GotoXY(CurX,CurY);
End;


Procedure ZXWindow.ClrEol;
Type WordRec = Record Lo, Hi : Byte; End;
Var data : Word;
    x : Byte;
Begin
  WordRec(data).Hi := TextAttr;
  WordRec(data).Lo := Byte(' ');
  For x := CurX To Lg-2 Do Poke(data,x,CurY);
End;


Procedure ZXWindow.ClrScr;
Begin
  ScrollUp(0);
  CurX := 1;
  CurY := 1;
  ZXPlan.GotoXY(CurX,CurY);
End;


Procedure ZXWindow.DelLine;
Begin
  ZXPlan.ScrollUp(1,CurY,Lg-2,Ht-CurY-1,1,TextAttr);
End;


Procedure ZXWindow.InsLine;
Begin
  ZXPlan.ScrollDown(1,CurY,Lg-2,Ht-CurY-1,1,TextAttr);
End;


Procedure ZXWindow.DirectChar( cx, cy : Byte; c : Char );
Type WordRec = Record Lo, Hi : Byte; End;
Var data : Word;
Begin
  If (cx>0) And (cy>0) And (cx<Lg-1) And (cy<Ht-1) Then
    Begin
      WordRec(data).Hi := TextAttr;
      WordRec(data).Lo := Byte(c);
      Poke(data,cx,cy);
    End;
End;


Procedure ZXWindow.DirectWrite( cx, cy : Byte; Text : String );
Var i : Byte;
Begin
  For i := 1 To Length(Text) Do DirectChar(cx+i-1, cy, Text[i]);
End;


Procedure ZXWindow.WriteChar( c : Char );
Type WordRec = Record Lo, Hi : Byte; End;
Var data : Word;
Begin
  If c=#7 Then Bell
  Else If c=#8 Then Backspace
    Else If c=#10 Then LineFeed
      Else If c=#13 Then CarriageReturn
        Else
          Begin
            WordRec(data).Hi := TextAttr;
            WordRec(data).Lo := Byte(c);
            Poke(data,CurX,CurY);
            Inc(CurX);
            If CurX>=Lg-1 Then
              Begin
                CurX := 1;
                LineFeed;
              End
            Else ZXPlan.GotoXY(CurX,CurY);
          End;
End;


Procedure ZXWindow.Write( s : String );
Var i : Byte;
Begin
  For i := 1 To Length(s) Do WriteChar(s[i]);
End;


Procedure ZXWindow.WriteLn( s : String );
Var i : Byte;
Begin
  For i := 1 To Length(s) Do WriteChar(s[i]);
  LineFeed;
  CarriageReturn;
End;


Procedure ZXWindow.HighVideo;
Begin
  TextAttr := TextAttr Or 8;
End;


Procedure ZXWindow.LowVideo;
Begin
  TextAttr := TextAttr And Not(8);
End;


Procedure ZXWindow.NormVideo;
Begin
  TextAttr := CTextWhite+CBackBlack;
End;


Procedure ZXWindow.SetColor( c : Byte );
Var a : Byte;
Begin
  Case c And 3 Of
    1 : a := CTextDark;
    2 : a := CTextGray;
    3 : a := CTextWhite;
  Else a := CTextBlack;
  End;
  If c And BackGray<>0 Then a := a Or CBackGray Else a := a Or CBackBlack;
  If c And TextBlink<>0 Then a := a Or 128;
  TextAttr := a;
End;


Function  ZXWindow.Active : Boolean;
Begin
  Active := CurrentEnablePlan=plan;
End;
